local CFG = require "supertable.core"
local DC = require "supertable.declare"

--配置文件路径
local _M = {
	config_file = "/data/configs/talkback.conf"
}

--对讲设备的结构体信息
local talk_set_decl = DC.OBJ {
    link_token= DC.STR(),
    link_name= DC.STR(),
    selected_ip= DC.STR(),--已经选中的设备ip
    devices= DC.SET( DC.OBJ {
            id= DC.STR(),
            name= DC.STR(),
            username= DC.STR(),
            password= DC.STR(),
            address= DC.STR("0.0.0.0"),
            port= DC.STR(),
            type= DC.STR(),--是设备还是通话服务器
            link_token= DC.STR()
    } )
   
}: __changed( function(conf)
        conf:TAB_SAVE()
end )

--默认初始化对讲设备的对象内容信息
local failDefault={
    link_token = "123456789",
    link_name = "KILOVIEW",
    selected_ip= "0.0.0.0",--已经选中的设备ip
    devices={}
}

--加载对接设备的设备列表信息
function _M.Load(file)
    local gen_set = CFG.Create( {}, talk_set_decl )
    gen_set:TAB_STORAGE( "file", { file = _M.config_file } )
    local _, r = gen_set:TAB_LOAD()
    if not r then
        gen_set:TAB_BIND( failDefault )
    end
    gen_set:TAB_RESET_CHANGE()
    return gen_set
end

return _M
