--The CODEC service
local encoders = require "encoders"

---------------------------------------------------

local CODECS_SVC = {
	Identifier = "Codecs",
	FriendlyName = "EC208E codecs service",
	Version = "1.0",
	WithEncoders = true,
	WithDecoders = false,
	ConfigPrefix = "codecs",
}

function CODECS_SVC:Activate()
end

function CODECS_SVC:Start()
end

function CODECS_SVC:Stop()
end

function CODECS_SVC:Reset()
	encoders.NotifyReset()
end

function CODECS_SVC:Terminate()
	os.exit(0)
end

function CODECS_SVC:Control(action,params)
	if action == "activate" then
		self:Activate()
		return 0, {}
	elseif action == "start" then
		self:Start()
		return 0, {}
	elseif action == "stop" then
		self:Stop()
		return 0, {}
	elseif action == "Reset" then
		self:Reset()
		return 0, {}
	elseif action == "terminate" then
		self:Terminate()
		return 0, {}
	else
		return -1, {}
	end
end

function CODECS_SVC:Set(params)
	return 0	--Nothing set.
end

function CODECS_SVC:SetEnv(params)
	return 0	--Nothing set.
end

function CODECS_SVC:Get(inParams)
	return 0, inParams
end

function CODECS_SVC:GetEnv(inParams)
	return 0, inParams
end

function CODECS_SVC:RestoreDefault()
	return 0
end

----------------------------------------------------

local _M = {}

function _M.Init( cosvc )
	if cosvc then
		cosvc:ExposeObject( "/Codec", CODECS_SVC )
	end
	print( "Codecs service online." )
end

---- Each second checking

function _M.Check()
end

return _M




