--The ENCODERS service
local mo_encoder = require "encoder"
local getset = require "kiloview.getSetHelper"

local CONFIG_FILE = "/data/configs/encoder.conf"

require "configuredb"
require "encoders_config"

---------------------------------------------------

_G.encoder = CONFIGS.InstanceOf( Encoders_Template, "encoder" )
_G.encoder:LoadFile( CONFIG_FILE )
_G.encoder:ResetChanges()
--_G.encoder:SaveFile()
---------------------------------------------------

local ENCODERS_SVC = {
	Identifier = "Encoders",
	FriendlyName = "EC208E Encoders service",
	ConfigPrefix = "encoder",
}

function ENCODERS_SVC:Activate()
end

function ENCODERS_SVC:Start()
	--TODO: TO start all encoders
end

function ENCODERS_SVC:Stop()
	--TODO: TO stop all encoders
end

function ENCODERS_SVC:Reset()
	mo_encoder.NotifyReset()
end

function ENCODERS_SVC:Terminate()
	--TODO: Now force exit for encoders terminate.
	os.exit(0)
end

function ENCODERS_SVC:Control(action,params)
	if action == "activate" then
		self:Activate()
		return 0, {}
	elseif action == "start" then
		self:Start()
		return 0, {}
	elseif action == "stop" then
		self:Stop()
		return 0, {}
	elseif action == "Reset" then
		self:Reset()
		return 0, {}
	elseif action == "terminate" then
		self:Terminate()
		return 0, {}
	elseif action == "getEncoders" then
		return self:GetEncoders()
	else
		return -1, {}
	end
end

function ENCODERS_SVC:Set(params)
	local cnt = getset.SetConfigureValues( self.ConfigPrefix, params )
	return cnt
end

function ENCODERS_SVC:SetEnv(params)
	local cnt = getset.SetValues( "_ENV", params )
	return cnt
end

function ENCODERS_SVC:Get(inParams)
	local cnt = getset.GetValues( self.ConfigPrefix, inParams )
	return cnt,inParams
end

function ENCODERS_SVC:GetEnv(inParams)
	local cnt = getset.GetValues( "_ENV", inParams )
	return cnt,inParams
end

function ENCODERS_SVC:RestoreDefault()
	return 0
end

function ENCODERS_SVC:LoadConfigureFile(filename)
	CONFIGS.BeginUpdate()
	local r = pcall( dofile, filename )
	CONFIGS.Submit()
	if r then
		return 1
	else
		return 0
	end
end

function ENCODERS_SVC:GetEncoders()
	return 2, {["00"] = "Channel 1", ["01"] = "Channel 2"}
end

----------------------------------------------------

local _M = {}

function _M.Init( cosvc )
	if cosvc then
		cosvc:ExposeObject("/Codec/Encoders", ENCODERS_SVC)
	end
	print( "Encoders service online." )
end

---- Each second checking

function _M.Check()
end

function _M.NotifyReset()
	ENCODERS_SVC:Reset()
end

return _M




