local _M = {}

local specialSize = {
	["480i"] = { width=720, height=480, interlace = true },
	["576i"] = { width=720, height=576, interlace = true },
	["525i"] = { width=720, height=480, interlace = true },
	["625i"] = { width=720, height=576, interlace = true },
	["480p"] = { width=720, height=480 },
	["576p"] = { width=720, height=576 },
	["720p"] = { width=1280, height=720 },
	["1080i"] = { width=1920, height=1080, interlace = true },
	["1080p"] = { width=1920, height=1080 },
	["2160p"] = { width=3840, height=2160 },
	["D480I"] = { width=720, height=480, interlace = true },
	["D576I"] = { width=720, height=576, interlace = true },
	["D480P"] = { width=720, height=480 },
	["D576P"] = { width=720, height=576 },
	["D720P"] = { width=1280, height=720 },
	["D1080I"] = { width=1920, height=1080, interlace = true },
	["D1080P"] = { width=1920, height=1080 },
	["D960x240"] = { width=960, height=240 },
	["D320x240"] = { width=320, height=240 },
	["D320x288"] = { width=320, height=288 }, 
	["D360x240"] = { width=360, height=240 }, 
	["D360x288"] = { width=360, height=288 }, 
	["D480x640"] = { width=480, height=640 }, 
	["D480x800"] = { width=480, height=800 }, 
	["hvga"] = { width=480, height=320 },
	["vga"] = { width=640, height=480 },
	["wvga"] = { width=800, height=480 }, 
	["D240x400"] = { width=240, height=400 }, 
	["xga"] = { width=1024, height=768 }, 
	["wsvga"] = { width=1024, height=600 }, 
	["D960x540"] = { width=960, height=540 },
}

function _M.GetMatchedFormat( w, h, i )
	local k,v
	for k,v in pairs(specialSize) do
		if w == v.width and h == v.height and (not i or i == v.interlace) then
			return k
		end
	end

	if w <= 1280 and h <= 720 then
		return "720p"
	else
		return "1080p"
	end
end


function _M.GetSizeFromFormat( format )
	local decl = specialSize[format]
	if decl then
		return decl.width, decl.height
	else
		local pat = format:match(".+p")
		if not pat then
			pat = format:match( ".+i" )
			if not pat then
				pat = format:match( ".+P" )
				if not pat then
					pat = format:match( ".+I" )
				end
			end
		end

		if pat then
			decl = specialSize[pat]
			if decl then
				return decl.width, decl.height
			end
		end

		local w, h = format:match("(%d+)x(%d+)")
		if w and h then
			return tonumber(w), tonumber(h)
		else
			return 0,0
		end
	end
end

return _M


