local checker = require "statusChecker"

local _M = {
    num = 0
}

--The M2 device IO/LEDs control parameters
_G.IOLED_OPTIONS = 
{
	WITH_FPGA = false,	--With FPGA
	FPGA_DEV_ADDR = 0xf4,	--FPGA I2C device address
	WITH_FPGA_LEDS = false,	--No FPGA LEDs
	------
	RESET_PIN = 9,	--GPIO9 as RESET button
	
	------
	GPIO_LEDS = {
		["running"] = 81,
		["link"] = 82
--		["signal"] = 58,
--		["link"] = 57
	},
	
	------
	FPGA_LEDS = {
	},
	
	------
	--Rolling options: When pressed (but no arrived reset time) RESET button, rolling LEDs
	ROLLING_SEQ = { "running", "link" },
	ROLLING_LANG_STATUS = {
		[0x01] = "BLINK",	--Default language is CN
		[0x04] = "BLINK-FAST",	--Default language is EN
		[0x00] = "BLINK-FAST"	--Other languages
	},
	
	ROLLING_MIN_NUMS = 2,	--How many leds at least show when rolling (Multiple languages support should +1)
	------
	ACTION_STATUS = {
		["default"] = {
			["running"] = "OFF",
			["link"] = "OFF",
		},
	
		["restore"] = {
			["running"] = "OFF",
			["link"] = "OFF",
		},
	
		["reboot"] = {
			["running"] = "OFF",
			["link"] = "OFF",
		},
		
		["reset"] = {
			["running"] = "BLINK",
			["link"] = "BLINK",
		}
	},
	-------
	RESET_HOLD = 5000	--Hold RESET button more than this value(milliseconds), should do restore factory action!
}

local ctrl_module = nil

function _M.Check(period_ms)
    _M.num = _M.num + 1

    if _M.num>=20 then -- 5秒检测一次
        _M.num = 0
    else
        return
    end

	if not ctrl_module then
		ctrl_module = require( "controlModule" )
	end
	
	if not ctrl_module then
		return
	end
	
	if not checker then
		return
	end
	
	--Signal checking
	local running = checker.CheckCodecModules()
	if running then
		ctrl_module.LedControl( "running", "BLINK-FAST" )
	else
		ctrl_module.LedControl( "running", "ON" )
	end
	
	local status = checker.CheckEthStatus()

    if status then
        ctrl_module.LedControl( "link", "ON" )
    else
        ctrl_module.LedControl( "link", "OFF" )
    end

end

-----------

return _M
