require "kiloview.configure_helper"
require "features"

local avahi
local function onLocalLinkChange(obj)
	if type(g__UpdateLocalLink) == "funciton" then
		g__UpdateLocalLink()
	end
	avahi = require "mod.avahiManager"
	if avahi then
		avahi.start()
	end
end

local function onRndisLinkChange(obj)
	local rndis_if = require "rndis_if"
	rndis_if.UpdateRndisLink()
end

local function onWifiSpecChange(obj)
	if type(g__UpdateWifiSpec) == "function" then
		g__UpdateWifiSpec()
	end
end

local function onOMNIServiceChanged(obj)
	if not _G.FEATURE_SUPPORT_OMNI then
		return 
	end

	local pid
	os.execute("/bin/rm -rf /etc/systemd/system/multi-user.target.wants/discover_ip.service")
	local f = io.popen("/bin/ps -ef | /bin/grep 'discover.sh' | /bin/grep -v /bin/grep | /usr/bin/awk '{print $2}'", "r")
	if f then
		pid = f:read("*l")
	end

	os.execute("systemctl stop discover_ip.service")

	if tonumber(obj.enable) == 1 then
		os.execute("/bin/ln -s /usr/lib/systemd/system/discover_ip.service /etc/systemd/system/multi-user.target.wants/discover_ip.service")
		if not pid then
			os.execute("/bin/bash /opt/discover.sh >/dev/null 2>&1 &")
		end
	else
		if pid and pid ~= "" then
			os.execute("/bin/kill -9 " .. pid)
		end
	end
end

HOSTAPM_Template = OBJECT({
	enableOMNI = OBJECT({
		enable = { type="integer", value = 0 },
	}, onOMNIServiceChanged),

	share = OBJECT({
		device = { type="string", value="wlan1" },
		enable = { type="string", value="true" },
		deviceType = { type="string", value="wifi" },
		shareDevice = { type="string", value="ppp0" },
		hostAp = { type="string", value="CAST_AP" },
		shareKey = { type="string", value="12345678" },
		ipRange = { type="string", value="192.168.250." },
		ipPrefix = { type="integer", value=24 },
		wifiChannel = { type="integer", value=6 },
		hideSsid = { type="integer", value=0 }
	}),
	
	localLink = OBJECT({
		enable = { type="string", value="true" },
		device = { type="string", value="eth0" },
		subdevice = { type="string", value="0" },
		ip = { type="string", value="192.168.1.168" },
		netmask = { type="string", value="255.255.255.0" },
--		gw = { type="string", value="" }
	}, onLocalLinkChange),	
	
	rndisLink = OBJECT({
		enable = { type="string", value="true" },
		ip = { type="string", value="10.10.10.10" },
		netmask = { type="string", value="255.255.255.0" },
		--dhcpStart = { type="string", value="10.10.10.100" },
		--dhcpEnd = { type="string", value="10.10.10.254" }
	}, onRndisLinkChange),	

	wifiSpecConfig = OBJECT({
		country_code = { type="string", value="0x0c" }, --Default, China
		roaming = { type="integer", value=0 },
		roaming_rssi_thres = { type="integer", value=10 },
		roaming_scan_intv = { type="integer", value=10000 }
	}, onWifiSpecChange),
})

