local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/netlink.conf"
}

----------------------------
local portfwd_template = DC.OBJ({
    addr = DC.STR(""),
    port = DC.NUM(60000),
    authcode = DC.STR(""),
    timeout = DC.NUM(15),
}) : __changed( function(conf,name,action)
	conf:TAB_SAVE()
end)

-------------------------------------------

local failDefault = {
    addr = "172.11.49.70",
    port = 60000,
    authcode = "",
    timeout = 15,
}

function _M.Load()
	local conf = CONF.Create({}, portfwd_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then
		conf:TAB_BIND(failDefault)
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-----------------------------------------------------------

return _M


