local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/ethernet.conf"
}

----------------------------
local ethernet_template = DC.SET(
	DC.OBJ({
		auto_neg = DC.STR("on"),
		speed = DC.STR("100"),
		duplex = DC.STR("full")
	})
) : __changed( function(conf,name,action)
	conf:TAB_SAVE()
end)

-------------------------------------------

local failDefault = {
	["eth0"] = {
		auto_neg = "on",
		speed = "",
		duplex = "full"
	}
}

function _M.Load()
	local conf = CONF.Create({}, ethernet_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then
		conf:TAB_BIND(failDefault)
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-----------------------------------------------------------

return _M


