local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/modem.conf"
}

----------------------------
local modem_template = DC.OBJ({
	modem1 = DC.STR(""),
	modem2 = DC.STR(""),
	modem3 = DC.STR(""),
	modem4 = DC.STR("")
}) : __changed( function(conf,name,action)
	conf:TAB_SAVE()
end)

-------------------------------------------

local failDefault = {
	modem1 = "/sys/devices/e0000000.ahb/e0018000.ehci/usb2/2-1/2-1.2",
	modem2 = "/sys/devices/e0000000.ahb/e0018000.ehci/usb2/2-1/2-1.4",
	modem3 = "/sys/devices/e0000000.ahb/e0018000.ehci/usb2/2-2",
	modem4 = "/sys/devices/e0000000.ahb/e0018000.ehci/usb2/2-1/2-1.3"
}

function _M.Load()
	local conf = CONF.Create({}, modem_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then --Try load a fail-default configure
		conf:TAB_BIND(failDefault)
		conf:TAB_SAVE()
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-----------------------------------------------------------

return _M


