local _M = {}
local busOprs = require "busOprs"

-----------------------------------------


local AllAudioSources = {
[1] = {
	token = "000",
	Channels = 2
},

[2] = {
	token = "001",
	Channels = 2
}
}

--[==[
{
	__sizeAudioSources: <int>
	AudioSources[...]: 
	{
		token: <char*> (!)
		Channels: <int> (!)
		__size: <int>
		__any: <_XML>
		__anyAttribute: <_XML>
	}
}
]==]

-----------------------------------------

local AllVideoSources = {
[1] = {
	token = "000",
	Framerate = 60,
	Resolution = { Width = 1920, Height = 1080 },
	Imaging = { Brightness = 0, ColorSaturation = 0, Contrast = 0 },
},

[2] = {
	token = "001",
	Framerate = 60,
	Resolution = { Width = 1920, Height = 1080 },
	Imaging = { Brightness = 0, ColorSaturation = 0, Contrast = 0 },
}
}


--[==[ *ABSTRACT* The 'VideoSources' arguments:
{
	__sizeVideoSources: <int>
	VideoSources[...]: 
	{
		token: <char*> (!)
		Framerate: <float> (!)
		Resolution: (!)
		{
			Width: <int> (!)
			Height: <int> (!)
		}
		Imaging: 
		{
			BacklightCompensation: 
			{
				Mode: (!)
				(
					tt__BacklightCompensationMode__OFF: 0,
					tt__BacklightCompensationMode__ON: 1,
				)
				Level: <float> (!)
			}
			Brightness: <float*>
			ColorSaturation: <float*>
			Contrast: <float*>
			Exposure: 
			{
				Mode: (!)
				(
					tt__ExposureMode__AUTO: 0,
					tt__ExposureMode__MANUAL: 1,
				)
				Priority: (!)
				(
					tt__ExposurePriority__LowNoise: 0,
					tt__ExposurePriority__FrameRate: 1,
				)
				Window: (!)
				{
					bottom: <float*>
					top: <float*>
					right: <float*>
					left: <float*>
				}
				MinExposureTime: <float> (!)
				MaxExposureTime: <float> (!)
				MinGain: <float> (!)
				MaxGain: <float> (!)
				MinIris: <float> (!)
				MaxIris: <float> (!)
				ExposureTime: <float> (!)
				Gain: <float> (!)
				Iris: <float> (!)
			}
			Focus: 
			{
				AutoFocusMode: (!)
				(
					tt__AutoFocusMode__AUTO: 0,
					tt__AutoFocusMode__MANUAL: 1,
				)
				DefaultSpeed: <float> (!)
				NearLimit: <float> (!)
				FarLimit: <float> (!)
				__size: <int>
				__any: <_XML>
				__anyAttribute: <_XML>
			}
			IrCutFilter: 
			(
				tt__IrCutFilterMode__ON: 0,
				tt__IrCutFilterMode__OFF: 1,
				tt__IrCutFilterMode__AUTO: 2,
			)
			Sharpness: <float*>
			WideDynamicRange: 
			{
				Mode: (!)
				(
					tt__WideDynamicMode__OFF: 0,
					tt__WideDynamicMode__ON: 1,
				)
				Level: <float> (!)
			}
			WhiteBalance: 
			{
				Mode: (!)
				(
					tt__WhiteBalanceMode__AUTO: 0,
					tt__WhiteBalanceMode__MANUAL: 1,
				)
				CrGain: <float> (!)
				CbGain: <float> (!)
				__size: <int>
				__any: <_XML>
				__anyAttribute: <_XML>
			}
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
			__anyAttribute: <_XML>
		}
		Extension: 
		{
			__size: <int>
			__any: <_XML>
			Imaging: 
			{
				BacklightCompensation: 
				{
					Mode: (!)
					(
						tt__BacklightCompensationMode__OFF: 0,
						tt__BacklightCompensationMode__ON: 1,
					)
					Level: <float*>
				}
				Brightness: <float*>
				ColorSaturation: <float*>
				Contrast: <float*>
				Exposure: 
				{
					Mode: (!)
					(
						tt__ExposureMode__AUTO: 0,
						tt__ExposureMode__MANUAL: 1,
					)
					Priority: 
					(
						tt__ExposurePriority__LowNoise: 0,
						tt__ExposurePriority__FrameRate: 1,
					)
					Window: 
					{
						bottom: <float*>
						top: <float*>
						right: <float*>
						left: <float*>
					}
					MinExposureTime: <float*>
					MaxExposureTime: <float*>
					MinGain: <float*>
					MaxGain: <float*>
					MinIris: <float*>
					MaxIris: <float*>
					ExposureTime: <float*>
					Gain: <float*>
					Iris: <float*>
				}
				Focus: 
				{
					AutoFocusMode: (!)
					(
						tt__AutoFocusMode__AUTO: 0,
						tt__AutoFocusMode__MANUAL: 1,
					)
					DefaultSpeed: <float*>
					NearLimit: <float*>
					FarLimit: <float*>
					Extension: 
					{
						__size: <int>
						__any: <_XML>
					}
					__anyAttribute: <_XML>
				}
				IrCutFilter: 
				(
					tt__IrCutFilterMode__ON: 0,
					tt__IrCutFilterMode__OFF: 1,
					tt__IrCutFilterMode__AUTO: 2,
				)
				Sharpness: <float*>
				WideDynamicRange: 
				{
					Mode: (!)
					(
						tt__WideDynamicMode__OFF: 0,
						tt__WideDynamicMode__ON: 1,
					)
					Level: <float*>
				}
				WhiteBalance: 
				{
					Mode: (!)
					(
						tt__WhiteBalanceMode__AUTO: 0,
						tt__WhiteBalanceMode__MANUAL: 1,
					)
					CrGain: <float*>
					CbGain: <float*>
					Extension: 
					{
						__size: <int>
						__any: <_XML>
					}
					__anyAttribute: <_XML>
				}
				Extension: 
				{
					__size: <int>
					__any: <_XML>
					ImageStabilization: 
					{
						Mode: (!)
						(
							tt__ImageStabilizationMode__OFF: 0,
							tt__ImageStabilizationMode__ON: 1,
							tt__ImageStabilizationMode__AUTO: 2,
							tt__ImageStabilizationMode__Extended: 3,
						)
						Level: <float*>
						Extension: 
						{
							__size: <int>
							__any: <_XML>
						}
						__anyAttribute: <_XML>
					}
					Extension: 
					{
						__size: <int>
						__any: <_XML>
					}
				}
				__anyAttribute: <_XML>
			}
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
		}
		__anyAttribute: <_XML>
	}
}
]==]

----------------------------------------------------------

local AllVideoSourceConfigs = {
	[1] = {
		token = "000",
		Name = "VideoSourceInput_Main",
		UseCount = 1,
		SourceToken = "000",
		Bounds = {
			x = 0, y = 0, width=1920, height=1080
		},
		Extension = {
			Rotate = {
				Mode = tt__RotateMode__OFF, Degree = 0
			}
		}
	},

	[2] = {
		token = "001",
		Name = "VideoSourceInput_Sub",
		UseCount = 1,
		SourceToken = "001",
		Bounds = {
			x = 0, y = 0, width=1920, height=1080
		},
		Extension = {
			Rotate = {
				Mode = tt__RotateMode__OFF, Degree = 0
			}
		}
	}
}

local AllAudioSourceConfigs = {
	[1] = {
		token = "000",
		Name = "AudioSourceInput_Main",
		UseCount = 1,
		SourceToken = "000",
	},
	
	[2] = {
		token = "001",
		Name = "AudioSourceInput_Sub",
		UseCount = 1,
		SourceToken = "001",
	}
}

----------------------------------------------------------
function _M.UpdateAVSourcesAndConfigs()
	local streamSt, streamInfo
	local signals = busOprs.GetSignalStatus()
	local cc, gets = busOprs.Get( {
		["avio.video.brightness"] = 128,
		["avio.video.contrast"] = 128,
		["avio.video.saturation"] = 128,
		["avio.video.hue"] = 128,
		["avio.video.RMF"] = "0"
	} )

	local streamTokens = {
		[0] = "00", [1] = "01"
	}

	for stream = 0, 1 do
		streamSt = busOprs.GetStreamStatus( streamTokens[stream] )
		if streamSt then
			cc, streamInfo = busOprs.Get({
				["encoder.stream[" .. stream .. "].video.framerate"] = 0,
				["encoder.stream[" .. stream .. "].video.bitrate"] = 0,
				["encoder.stream[" .. stream .. "].video.profile"] = "baseline",
				["encoder.stream[" .. stream .. "].video.gop_size"] = 30,
				["encoder.stream[" .. stream .. "].video.quality"] = 0,
			})

			local x = streamInfo["encoder.stream[" .. stream .. "].video.framerate"] or 0
			if x <= 0 then
				AllVideoSources[stream+1].Framerate = signals.video[ "video.frame_rate"]
			elseif x == 0.5 then
				AllVideoSources[stream+1].Framerate = signals.video[ "video.frame_rate"]/2
			else
				AllVideoSources[stream+1].Framerate = x
			end

			AllVideoSources[stream+1].Resolution = { Width = streamSt["video.width"] or 0, Height = streamSt["video.height"] or 0 }
			AllVideoSources[stream+1].Imaging = { 
				Brightness = gets and gets["avio.video.brightness"] or 128,
				ColorSaturation = gets and gets["avio.video.saturation"] or 128,
				Contrast = gets and gets["avio.video.contrast"] or 128,
			}
			
			AllVideoSourceConfigs[stream+1].Bounds = { x = 0, y = 0, width=streamSt["video.width"] or 0, height = streamSt["video.height"] or 0 }
			
			local rmf = gets and gets["avio.video.RMF"] or "0"
			if rmf == "0" then
				AllVideoSourceConfigs[stream+1].Extension.Rotate = { Mode = tt__RotateMode__OFF, Degree = 0 }
			elseif rmf == "mirror" or rmf == "flip" then
				AllVideoSourceConfigs[stream+1].Extension.Rotate = { Mode = tt__RotateMode__AUTO, Degree = (rmf == "flip" and 180 or 0) }
			else
				AllVideoSourceConfigs[stream+1].Extension.Rotate = { Mode = tt__RotateMode__ON, Degree = tonumber(rmf) }
			end

		end --If get stream_Status.
	end --For
end
----------------------------------------------------------

local FixedProfiles = {
	[1] = {
		token = "Profile_Main_00",
		Name = "MainStream_Profile",
		fixed = 1,
		
		VideoSourceConfiguration = AllVideoSourceConfigs[1],
		AudioSourceConfiguration = AllAudioSourceConfigs[1],
		
		VideoEncoderConfiguration = {
			Name = "MainVideoEncoder",
			UseCount = 1,
			token = "000",
			Encoding = tt__VideoEncoding__H264,
			
			Resolution = {
				Width = 1920,
				Height = 1080
			},
			
			Quality = 5,
			
			RateControl = { 
				FrameRateLimit = 30,
				EncodingInterval = 1,
				BitrateLimit = 2000
			},

			H264 = {
				GovLength = 30,
				H264Profile = tt__H264Profile__High
			},

			SessionTimeout = 0x7fffffff,
		},
		
		AudioEncoderConfiguration = {
			Name = "MainAudioEncoder",
			UseCount = 1,
			token = "000",
			Encoding = tt__AudioEncoding__AAC,
			Bitrate = 64000,
			SampleRate = 48000,
			Multicast = {
				Address = {
					Type = tt__IPType__IPv4,
					IPv4Address = "224.0.0.1"
				},
				Port = 60000,
				TTL = 127,
				AutoStart = 0,
			},
			
			SessionTimeout = 0x7fffffff,
		},
	},
	
	[2] = {
		token = "Profile_Sub_00",
		Name = "SubStream_Profile",
		fixed = 1,
		
		VideoSourceConfiguration = AllVideoSourceConfigs[2],
		AudioSourceConfiguration = AllAudioSourceConfigs[2],
		
		VideoEncoderConfiguration = {
			Name = "SubVideoEncoder",
			UseCount = 1,
			token = "001",
			Encoding = tt__VideoEncoding__H264,
			
			Resolution = {
				Width = 960,
				Height = 540
			},
			
			Quality = 5,
			
			RateControl = { 
				FrameRateLimit = 30,
				EncodingInterval = 1,
				BitrateLimit = 512
			},

			H264 = {
				GovLength = 30,
				H264Profile = tt__H264Profile__High
			},

			SessionTimeout = 0x7fffffff,
		},
		
		AudioEncoderConfiguration = {
			Name = "SubAudioEncoder",
			UseCount = 1,
			token = "001",
			Encoding = tt__AudioEncoding__AAC,
			Bitrate = 64000,
			SampleRate = 48000,
			Multicast = {
				Address = {
					Type = tt__IPType__IPv4,
					IPv4Address = "224.0.0.1"
				},
				Port = 60002,
				TTL = 127,
				AutoStart = 0,
			},
			
			SessionTimeout = 0x7fffffff,
		},
	}
}


function _M.UpdateAVEncoderConfigs(spec)
	if not spec or spec == 1 then --Update main stream
		local streamSt = busOprs.GetStreamStatus( "00" )
		if streamSt then
			local cc, gets = busOprs.Get({
				["encoder.stream[0].video.framerate"] = 0,
				["encoder.stream[0].video.bitrate"] = 0,
				["encoder.stream[0].video.profile"] = "baseline",
				["encoder.stream[0].video.gop_size"] = 30,
				["encoder.stream[0].video.quality"] = 0,
			})
			
			local isH264 = false
			if streamSt["video.codec"] == "H264" or streamSt["video.codec"] == "h264" or streamSt["video.codec"] == "H.264" or streamSt["video.codec"] == "h.264" then
				FixedProfiles[1].VideoEncoderConfiguration.Encoding = tt__VideoEncoding__H264
				isH264 = true
			elseif streamSt["video.codec"] == "JPEG" or streamSt["video.codec"] == "jpeg" or streamSt["video.codec"] == "MJPEG" or streamSt["video.codec"] == "mjpeg" then
				FixedProfiles[1].VideoEncoderConfiguration.Encoding = tt__VideoEncoding__JPEG
			end
			
			FixedProfiles[1].VideoEncoderConfiguration.Resolution = {
				Width = streamSt["video.width"] or 0,
				Height = streamSt["video.height"] or 0
			}
			
			local x
			x = gets and gets["encoder.stream[0].video.framerate"] or 0
			if x <= 0 then
				FixedProfiles[1].VideoEncoderConfiguration.RateControl.FrameRateLimit = AllVideoSources[1].Framerate
				FixedProfiles[1].VideoEncoderConfiguration.RateControl.EncodingInterval = 1
			elseif x == 0.5 then
				FixedProfiles[1].VideoEncoderConfiguration.RateControl.EncodingInterval = 2
				if AllVideoSources[1].Framerate <= 30 then
					FixedProfiles[1].VideoEncoderConfiguration.RateControl.FrameRateLimit = AllVideoSources[1].Framerate
				else
					FixedProfiles[1].VideoEncoderConfiguration.RateControl.FrameRateLimit = math.floor(AllVideoSources[1].Framerate/2)
				end
			else
				FixedProfiles[1].VideoEncoderConfiguration.RateControl.FrameRateLimit = x
				FixedProfiles[1].VideoEncoderConfiguration.RateControl.EncodingInterval = 0
			end
			
			FixedProfiles[1].VideoEncoderConfiguration.RateControl.BitrateLimit = (gets and gets["encoder.stream[0].video.bitrate"] or 0)/1000
			FixedProfiles[1].VideoEncoderConfiguration.Quality = gets and gets["encoder.stream[0].video.quality"] or 50
			
			if isH264 then
				FixedProfiles[1].VideoEncoderConfiguration.H264.GovLength = gets and gets["encoder.stream[0].video.gop_size"] or 30
				x = gets and gets["encoder.stream[0].video.profile"] or "baseline"
				if x == "base" or x == "baseline" then
					FixedProfiles[1].VideoEncoderConfiguration.H264.H264Profile = tt__H264Profile__Baseline
				elseif x == "main" then
					FixedProfiles[1].VideoEncoderConfiguration.H264.H264Profile = tt__H264Profile__Main
				elseif x == "high" then
					FixedProfiles[1].VideoEncoderConfiguration.H264.H264Profile = tt__H264Profile__High
				else
					FixedProfiles[1].VideoEncoderConfiguration.H264.H264Profile = tt__H264Profile__Baseline
				end				
			end
			
			if streamSt["audio.codec"] == "AAC" or streamSt["audio.codec"] == "MPEG4-GENERIC" then
				FixedProfiles[1].AudioEncoderConfiguration.Encoding = tt__AudioEncoding__AAC
			elseif streamSt["audio.codec"] == "G711" or streamSt["audio.codec"] == "PCMU" or streamSt["audio.codec"] == "PCMA" then
				FixedProfiles[1].AudioEncoderConfiguration.Encoding = _G.tt__AudioEncoding__G711
			else
				FixedProfiles[1].AudioEncoderConfiguration.Encoding = _G.tt__AudioEncoding__G711	--TODO:
			end
			FixedProfiles[1].AudioEncoderConfiguration.Bitrate = ( streamSt["audio.bitrate"] or 0 )/1000
			FixedProfiles[1].AudioEncoderConfiguration.SampleRate = streamSt["audio.sampling"] or 0
		end
	end
	
	if not spec or spec == 2 then --Update sub stream
		local streamSt = busOprs.GetStreamStatus( "01" )
		if streamSt then
			local cc, gets = busOprs.Get({
				["encoder.stream[1].video.framerate"] = 0,
				["encoder.stream[1].video.bitrate"] = 0,
				["encoder.stream[1].video.profile"] = "baseline",
				["encoder.stream[1].video.gop_size"] = 30,
				["encoder.stream[1].video.quality"] = 0,
			})
			
			local isH264 = false
			if streamSt["video.codec"] == "H264" or streamSt["video.codec"] == "h264" or streamSt["video.codec"] == "H.264" or streamSt["video.codec"] == "h.264" then
				FixedProfiles[2].VideoEncoderConfiguration.Encoding = tt__VideoEncoding__H264
				isH264 = true
			elseif streamSt["video.codec"] == "JPEG" or streamSt["video.codec"] == "jpeg" or streamSt["video.codec"] == "MJPEG" or streamSt["video.codec"] == "mjpeg" then
				FixedProfiles[2].VideoEncoderConfiguration.Encoding = tt__VideoEncoding__JPEG
			end
			
			FixedProfiles[2].VideoEncoderConfiguration.Resolution = {
				Width = streamSt["video.width"] or 0,
				Height = streamSt["video.height"] or 0
			}
			
			local x
			x = gets and gets["encoder.stream[1].video.framerate"] or 0
			if x <= 0 then
				FixedProfiles[2].VideoEncoderConfiguration.RateControl.FrameRateLimit = AllVideoSources[1].Framerate
				FixedProfiles[2].VideoEncoderConfiguration.RateControl.EncodingInterval = 1
			elseif x == 0.5 then
				FixedProfiles[2].VideoEncoderConfiguration.RateControl.EncodingInterval = 2
				if AllVideoSources[1].Framerate <= 30 then
					FixedProfiles[2].VideoEncoderConfiguration.RateControl.FrameRateLimit = AllVideoSources[1].Framerate
				else
					FixedProfiles[2].VideoEncoderConfiguration.RateControl.FrameRateLimit = math.floor(AllVideoSources[1].Framerate/2)
				end
			else
				FixedProfiles[2].VideoEncoderConfiguration.RateControl.FrameRateLimit = x
				FixedProfiles[2].VideoEncoderConfiguration.RateControl.EncodingInterval = 0
			end
			
			FixedProfiles[2].VideoEncoderConfiguration.RateControl.BitrateLimit = (gets and gets["encoder.stream[1].video.bitrate"] or 0)/1000
			FixedProfiles[2].VideoEncoderConfiguration.Quality = gets and gets["encoder.stream[1].video.quality"] or 50
			
			if isH264 then
				FixedProfiles[2].VideoEncoderConfiguration.H264.GovLength = gets and gets["encoder.stream[1].video.gop_size"] or 30
				x = gets and gets["encoder.stream[1].video.profile"] or "baseline"
				if x == "base" or x == "baseline" then
					FixedProfiles[2].VideoEncoderConfiguration.H264.H264Profile = tt__H264Profile__Baseline
				elseif x == "main" then
					FixedProfiles[2].VideoEncoderConfiguration.H264.H264Profile = tt__H264Profile__Main
				elseif x == "high" then
					FixedProfiles[2].VideoEncoderConfiguration.H264.H264Profile = tt__H264Profile__High
				else
					FixedProfiles[2].VideoEncoderConfiguration.H264.H264Profile = tt__H264Profile__Baseline
				end				
			end
			
			if streamSt["audio.codec"] == "AAC" or streamSt["audio.codec"] == "MPEG4-GENERIC" then
				FixedProfiles[2].AudioEncoderConfiguration.Encoding = tt__AudioEncoding__AAC
			elseif streamSt["audio.codec"] == "G711" or streamSt["audio.codec"] == "PCMU" or streamSt["audio.codec"] == "PCMA" then
				FixedProfiles[2].AudioEncoderConfiguration.Encoding = _G.tt__AudioEncoding__G711
			else
				FixedProfiles[2].AudioEncoderConfiguration.Encoding = _G.tt__AudioEncoding__G711	--TODO:
			end
			FixedProfiles[2].AudioEncoderConfiguration.Bitrate = ( streamSt["audio.bitrate"] or 0 )/1000
			FixedProfiles[2].AudioEncoderConfiguration.SampleRate = streamSt["audio.sampling"] or 0
		end
	end
end

--[==[ *ABSTRACT* The 'response' arguments:
{
	__sizeProfiles: <int>
	Profiles[...]: 
	{
		Name: <char*> (!)
		VideoSourceConfiguration: 
		{
			Name: <char*> (!)
			UseCount: <int> (!)
			token: <char*> (!)
			SourceToken: <char*> (!)
			Bounds: (!)
			{
				x: <int> (!)
				y: <int> (!)
				width: <int> (!)
				height: <int> (!)
			}
			__size: <int>
			__any: <_XML>
			Extension: 
			{
				Rotate: 
				{
					Mode: (!)
					(
						tt__RotateMode__OFF: 0,
						tt__RotateMode__ON: 1,
						tt__RotateMode__AUTO: 2,
					)
					Degree: <int*>
					Extension: 
					{
						__size: <int>
						__any: <_XML>
					}
					__anyAttribute: <_XML>
				}
				Extension: 
				{
					__size: <int>
					__any: <_XML>
				}
			}
			__anyAttribute: <_XML>
		}
		AudioSourceConfiguration: 
		{
			Name: <char*> (!)
			UseCount: <int> (!)
			token: <char*> (!)
			SourceToken: <char*> (!)
			__size: <int>
			__any: <_XML>
			__anyAttribute: <_XML>
		}
		VideoEncoderConfiguration: 
		{
			Name: <char*> (!)
			UseCount: <int> (!)
			token: <char*> (!)
			Encoding: (!)
			(
				tt__VideoEncoding__JPEG: 0,
				tt__VideoEncoding__MPEG4: 1,
				tt__VideoEncoding__H264: 2,
			)
			Resolution: (!)
			{
				Width: <int> (!)
				Height: <int> (!)
			}
			Quality: <float> (!)
			RateControl: 
			{
				FrameRateLimit: <int> (!)
				EncodingInterval: <int> (!)
				BitrateLimit: <int> (!)
			}
			MPEG4: 
			{
				GovLength: <int> (!)
				Mpeg4Profile: (!)
				(
					tt__Mpeg4Profile__SP: 0,
					tt__Mpeg4Profile__ASP: 1,
				)
			}
			H264: 
			{
				GovLength: <int> (!)
				H264Profile: (!)
				(
					tt__H264Profile__Baseline: 0,
					tt__H264Profile__Main: 1,
					tt__H264Profile__Extended: 2,
					tt__H264Profile__High: 3,
				)
			}
			Multicast: (!)
			{
				Address: (!)
				{
					Type: (!)
					(
						tt__IPType__IPv4: 0,
						tt__IPType__IPv6: 1,
					)
					IPv4Address: <char*>
					IPv6Address: <char*>
				}
				Port: <int> (!)
				TTL: <int> (!)
				AutoStart: (!)
				(
					xsd__boolean__false_: 0,
					xsd__boolean__true_: 1,
				)
				__size: <int>
				__any: <_XML>
				__anyAttribute: <_XML>
			}
			SessionTimeout: <LONG64> (!)
			__size: <int>
			__any: <_XML>
			__anyAttribute: <_XML>
		}
		AudioEncoderConfiguration: 
		{
			Name: <char*> (!)
			UseCount: <int> (!)
			token: <char*> (!)
			Encoding: (!)
			(
				tt__AudioEncoding__G711: 0,
				tt__AudioEncoding__G726: 1,
				tt__AudioEncoding__AAC: 2,
			)
			Bitrate: <int> (!)
			SampleRate: <int> (!)
			Multicast: (!)
			{
				Address: (!)
				{
					Type: (!)
					(
						tt__IPType__IPv4: 0,
						tt__IPType__IPv6: 1,
					)
					IPv4Address: <char*>
					IPv6Address: <char*>
				}
				Port: <int> (!)
				TTL: <int> (!)
				AutoStart: (!)
				(
					xsd__boolean__false_: 0,
					xsd__boolean__true_: 1,
				)
				__size: <int>
				__any: <_XML>
				__anyAttribute: <_XML>
			}
			SessionTimeout: <LONG64> (!)
			__size: <int>
			__any: <_XML>
			__anyAttribute: <_XML>
		}
		VideoAnalyticsConfiguration: 
		{
			Name: <char*> (!)
			UseCount: <int> (!)
			token: <char*> (!)
			AnalyticsEngineConfiguration: (!)
			{
				__sizeAnalyticsModule: <int>
				AnalyticsModule[...]: 
				{
					Parameters: (!)
					{
						__sizeSimpleItem: <int>
						SimpleItem[...]: 
						{
							Name: <char*> (!)
							Value: <char*> (!)
						}
						__sizeElementItem: <int>
						ElementItem[...]: 
						{
							__any: <_XML>
							Name: <char*> (!)
						}
						Extension: 
						{
							__size: <int>
							__any: <_XML>
						}
						__anyAttribute: <_XML>
					}
					Name: <char*> (!)
					Type: <_QName> (!)
				}
				Extension: 
				{
					__size: <int>
					__any: <_XML>
				}
				__anyAttribute: <_XML>
			}
			RuleEngineConfiguration: (!)
			{
				__sizeRule: <int>
				Rule[...]: 
				{
					Parameters: (!)
					{
						__sizeSimpleItem: <int>
						SimpleItem[...]: 
						{
							Name: <char*> (!)
							Value: <char*> (!)
						}
						__sizeElementItem: <int>
						ElementItem[...]: 
						{
							__any: <_XML>
							Name: <char*> (!)
						}
						Extension: 
						{
							__size: <int>
							__any: <_XML>
						}
						__anyAttribute: <_XML>
					}
					Name: <char*> (!)
					Type: <_QName> (!)
				}
				Extension: 
				{
					__size: <int>
					__any: <_XML>
				}
				__anyAttribute: <_XML>
			}
			__size: <int>
			__any: <_XML>
			__anyAttribute: <_XML>
		}
		PTZConfiguration: 
		{
			Name: <char*> (!)
			UseCount: <int> (!)
			token: <char*> (!)
			NodeToken: <char*> (!)
			DefaultAbsolutePantTiltPositionSpace: <char*>
			DefaultAbsoluteZoomPositionSpace: <char*>
			DefaultRelativePanTiltTranslationSpace: <char*>
			DefaultRelativeZoomTranslationSpace: <char*>
			DefaultContinuousPanTiltVelocitySpace: <char*>
			DefaultContinuousZoomVelocitySpace: <char*>
			DefaultPTZSpeed: 
			{
				PanTilt: 
				{
					x: <float> (!)
					y: <float> (!)
					space: <char*>
				}
				Zoom: 
				{
					x: <float> (!)
					space: <char*>
				}
			}
			DefaultPTZTimeout: <LONG64*>
			PanTiltLimits: 
			{
				Range: (!)
				{
					URI: <char*> (!)
					XRange: (!)
					{
						Min: <float> (!)
						Max: <float> (!)
					}
					YRange: (!)
					{
						Min: <float> (!)
						Max: <float> (!)
					}
				}
			}
			ZoomLimits: 
			{
				Range: (!)
				{
					URI: <char*> (!)
					XRange: (!)
					{
						Min: <float> (!)
						Max: <float> (!)
					}
				}
			}
			Extension: 
			{
				__size: <int>
				__any: <_XML>
				PTControlDirection: 
				{
					EFlip: 
					{
						Mode: (!)
						(
							tt__EFlipMode__OFF: 0,
							tt__EFlipMode__ON: 1,
							tt__EFlipMode__Extended: 2,
						)
						__size: <int>
						__any: <_XML>
						__anyAttribute: <_XML>
					}
					Reverse: 
					{
						Mode: (!)
						(
							tt__ReverseMode__OFF: 0,
							tt__ReverseMode__ON: 1,
							tt__ReverseMode__AUTO: 2,
							tt__ReverseMode__Extended: 3,
						)
						__size: <int>
						__any: <_XML>
						__anyAttribute: <_XML>
					}
					Extension: 
					{
						__size: <int>
						__any: <_XML>
						__anyAttribute: <_XML>
					}
					__anyAttribute: <_XML>
				}
				Extension: 
				{
					__size: <int>
					__any: <_XML>
				}
			}
			__anyAttribute: <_XML>
		}
		MetadataConfiguration: 
		{
			Name: <char*> (!)
			UseCount: <int> (!)
			token: <char*> (!)
			PTZStatus: 
			{
				Status: (!)
				(
					xsd__boolean__false_: 0,
					xsd__boolean__true_: 1,
				)
				Position: (!)
				(
					xsd__boolean__false_: 0,
					xsd__boolean__true_: 1,
				)
				__anyAttribute: <_XML>
			}
			Events: 
			{
				Filter: 
				{
					__size: <int>
					__any: <_XML>
				}
				SubscriptionPolicy: 
				{
					__size: <int>
					__any: <_XML>
				}
				__size: <int>
				__any: <_XML>
				__anyAttribute: <_XML>
			}
			Analytics: 
			(
				xsd__boolean__false_: 0,
				xsd__boolean__true_: 1,
			)
			Multicast: (!)
			{
				Address: (!)
				{
					Type: (!)
					(
						tt__IPType__IPv4: 0,
						tt__IPType__IPv6: 1,
					)
					IPv4Address: <char*>
					IPv6Address: <char*>
				}
				Port: <int> (!)
				TTL: <int> (!)
				AutoStart: (!)
				(
					xsd__boolean__false_: 0,
					xsd__boolean__true_: 1,
				)
				__size: <int>
				__any: <_XML>
				__anyAttribute: <_XML>
			}
			SessionTimeout: <LONG64> (!)
			__size: <int>
			__any: <_XML>
			AnalyticsEngineConfiguration: 
			{
				__sizeAnalyticsModule: <int>
				AnalyticsModule[...]: 
				{
					Parameters: (!)
					{
						__sizeSimpleItem: <int>
						SimpleItem[...]: 
						{
							Name: <char*> (!)
							Value: <char*> (!)
						}
						__sizeElementItem: <int>
						ElementItem[...]: 
						{
							__any: <_XML>
							Name: <char*> (!)
						}
						Extension: 
						{
							__size: <int>
							__any: <_XML>
						}
						__anyAttribute: <_XML>
					}
					Name: <char*> (!)
					Type: <_QName> (!)
				}
				Extension: 
				{
					__size: <int>
					__any: <_XML>
				}
				__anyAttribute: <_XML>
			}
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
			__anyAttribute: <_XML>
		}
		Extension: 
		{
			__size: <int>
			__any: <_XML>
			AudioOutputConfiguration: 
			{
				Name: <char*> (!)
				UseCount: <int> (!)
				token: <char*> (!)
				OutputToken: <char*> (!)
				SendPrimacy: <char*>
				OutputLevel: <int> (!)
				__size: <int>
				__any: <_XML>
				__anyAttribute: <_XML>
			}
			AudioDecoderConfiguration: 
			{
				Name: <char*> (!)
				UseCount: <int> (!)
				token: <char*> (!)
				__size: <int>
				__any: <_XML>
				__anyAttribute: <_XML>
			}
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
			__anyAttribute: <_XML>
		}
		token: <char*> (!)
		fixed: 
		(
			xsd__boolean__false_: 0,
			xsd__boolean__true_: 1,
		)
		__anyAttribute: <_XML>
	}
}
]==]

-----------------------------------------

function _M.GetAllProfiles()
	local ptzConfigs = require "ptzConfigs"
	local i
	for i=1, #FixedProfiles do
		FixedProfiles[i].PTZConfiguration = ptzConfigs.GetConfig("000")
	end
	_M.UpdateAVSourcesAndConfigs()
	_M.UpdateAVEncoderConfigs()


	local cc, gets = busOprs.Get( {
		["encoder.encode_mode"] = "main"
	})

	if gets and gets[ "encoder.encode_mode" ] and gets[ "encoder.encode_mode" ]:match("sub") then
		return FixedProfiles
	else
		return { FixedProfiles[1] }
	end
end

-----------------------------------------

function _M.GetProfile(token)
	local ptzConfigs = require "ptzConfigs"

	local i
	for i=1, #FixedProfiles do
		if FixedProfiles[i].token == token then
			FixedProfiles[i].PTZConfiguration = ptzConfigs.GetConfig("000")
			_M.UpdateAVSourcesAndConfigs()
			_M.UpdateAVEncoderConfigs(i)
			return FixedProfiles[i]
		end
	end
	return nil
end

-----------------------------------------
function _M.GetAllVideoSources()
	_M.UpdateAVSourcesAndConfigs()
	return AllVideoSources
end

-----------------------------------------
function _M.GetAllAudioSources()
	_M.UpdateAVSourcesAndConfigs()
	return AllAudioSources
end

-----------------------------------------
function _M.GetAllVideoSourceConfigs()
	_M.UpdateAVSourcesAndConfigs()
	return AllVideoSourceConfigs
end

-----------------------------------------
function _M.GetVideoSourceConfig(token)
	local i
	_M.UpdateAVSourcesAndConfigs()
	for i=1, #AllVideoSourceConfigs do
		if AllVideoSourceConfigs[i].token == token then
			return AllVideoSourceConfigs[i]
		end
	end
	return nil
end

-----------------------------------------
function _M.GetAllAudioSourceConfigs()
	_M.UpdateAVSourcesAndConfigs()
	return AllAudioSourceConfigs
end

-----------------------------------------
function _M.GetAudioSourceConfig(token)
	local i
	_M.UpdateAVSourcesAndConfigs()
	for i=1, #AllAudioSourceConfigs do
		if AllAudioSourceConfigs[i].token == token then
			return AllAudioSourceConfigs[i]
		end
	end
	return nil
end

-----------------------------------------
return _M

