local busOprs = require "busOprs"

local cc, gets = busOprs.Get( {
	["streamer.stream[0].Rtsp_server.port"] = 554,
	["streamer.stream[1].Rtsp_server.port"] = 554,
	["webConfig.port"] = 80,
	["webConfig.https_port"] = 443,
} )

local ports = { gets and gets["streamer.stream[0].Rtsp_server.port"] or 554 }
local second_port = gets and gets["streamer.stream[1].Rtsp_server.port"] or 554
if ports[1] ~= second_port then
	ports[2] = second_port
end

return {
	NetworkProtocols = {
		{
			Name = tt__NetworkProtocolType__HTTP,
			Enabled = _G.onvif.control.enabled,
			Port = { gets and gets["webConfig.port"] or 80 } --_G.onvif.control.port, 
		},
		
		{
			Name = tt__NetworkProtocolType__HTTPS,
			Enabled = _G.onvif.control.enabled,
			Port = { gets and gets["webConfig.https_port"] or 443 }
		},

		{
			Name = tt__NetworkProtocolType__RTSP,
			Enabled = 1,
			Port = ports
		}
	}
}

