local busOprs = require "busOprs"
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

if request.IPv4Address then
	local devices = busOprs.GetIfDevices("*")	--Get all devices.
	if devices then
		local k,v
		for k,v in pairs(devices) do
			if v.TypeName == "ETHERNET" and v.State > 10 then
				local ifconfig = busOprs.CheckIfConfig( v.Object, "WIRE" )
				if not ifconfig.dhcp then
					local i
					local matchAddr = nil
					for i=1, #request.IPv4Address do
						if OnvifSvc.Net.AddressMatch( request.IPv4Address[i], ifconfig.ip4addr, ifconfig.prefix ) then
							matchAddr = request.IPv4Address[i]
							break
						end
					end
					
					if matchAddr then
						local args = {
							obj = v.Object,
							uuid = ifconfig.uuid,
							dynamic = 'n',
							ip = ifconfig.ip4addr,
							mask = ifconfig.ip4mask,
							gw = matchAddr,
							dns1 = ifconfig.ip4dns1,
							dns2 = ifconfig.ip4dns2,
							specConn = ifconfig.specConn,
						}
					
						busOprs.SetWireIfConfig(args)
						busOprs.UpdateIfConfig(v.Object)
					end --of if matched gateway address.
				end --if not DHCP
			end -- if ethernet
		end --For
	end --get 'devices'
	
	return SVC_OK	--TODO: ???
else
	return SVC_OK
end

--[==[ *ABSTRACT* The 'request' arguments:
{
	__sizeIPv4Address: <int>
	IPv4Address: <char**>
	__sizeIPv6Address: <int>
	IPv6Address: <char**>
}
]==]

