local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local busOprs = require "busOprs"
local rtspCC = 0
local sets = {}

if request.NetworkProtocols then
	local i
	for i=1, #request.NetworkProtocols do
		if request.NetworkProtocols[i].Name == tt__NetworkProtocolType__HTTP or request.NetworkProtocols[i].Name == tt__NetworkProtocolType__HTTPS then
			if request.NetworkProtocols[i].Enabled == 0 then	--Disable Onvif service
				sets["onvif.control.enabled"] = 0
			elseif request.NetworkProtocols[i].Port then
				sets["onvif.control.enabled"] = 1
				if request.NetworkProtocols[i].Port[1] then
					if request.NetworkProtocols[i].Name == tt__NetworkProtocolType__HTTPS then
						sets["webConfig.https_port"] = request.NetworkProtocols[i].Port[1]
					else
						sets["webConfig.port"] = request.NetworkProtocols[i].Port[1]
					end
				end
			end

		elseif request.NetworkProtocols[i].Name == tt__NetworkProtocolType__RTSP and request.NetworkProtocols[i].Enabled and request.NetworkProtocols[i].Port then
			local j
			for j=1, #request.NetworkProtocols[i].Port do
				rtspCC = rtspCC + 1
				if rtspCC == 1 then
					sets["streamer.stream[0].Rtsp_server.port"] = request.NetworkProtocols[i].Port[j]
					sets["streamer.stream[1].Rtsp_server.port"] = request.NetworkProtocols[i].Port[j]	--Sub stream is same as main.
				else
					sets["streamer.stream[1].Rtsp_server.port"] = request.NetworkProtocols[i].Port[j]
				end
			end
		end
	end --For.
	
	busOprs.Set( sets )
end

return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	__sizeNetworkProtocols: <int> (!)
	NetworkProtocols[...]: (!)
	{
		Name: (!)
		(
			tt__NetworkProtocolType__HTTP: 0,
			tt__NetworkProtocolType__HTTPS: 1,
			tt__NetworkProtocolType__RTSP: 2,
		)
		Enabled: (!)
		(
			xsd__boolean__false_: 0,
			xsd__boolean__true_: 1,
		)
		__sizePort: <int> (!)
		Port: <int*> (!)
		Extension: 
		{
			__size: <int>
			__any: <_XML>
		}
		__anyAttribute: <_XML>
	}
}
]==]


