local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

--[==[ *ABSTRACT* The 'request' arguments:
{
	VideoSourceToken: <char*> (!)
}
]==]

return {
	ImagingOptions = {
		Brightness = { Min=0, Max=255 },
		ColorSaturation = { Min=0, Max=255 },
		Contrast = { Min=0, Max=255 },

		Focus =
		{
			AutoFocusModes = { 0, 1 },
			DefaultSpeed = 
			{
				Min = -1,
				Max = 1
			},

			NearLimit =
			{
				Min = -100,
				Max = 10
			},

			FarLimit = 
			{
				Min = 10,
				Max = 100
			}
		}
	}
}

--[==[ *ABSTRACT* The 'response' arguments:
{
	ImagingOptions: (!)
	{
		BacklightCompensation: 
		{
			__sizeMode: <int> (!)
			Mode[...]: (!)
			(
				tt__BacklightCompensationMode__OFF: 0,
				tt__BacklightCompensationMode__ON: 1,
			)
			Level: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
		}
		Brightness: 
		{
			Min: <float> (!)
			Max: <float> (!)
		}
		ColorSaturation: 
		{
			Min: <float> (!)
			Max: <float> (!)
		}
		Contrast: 
		{
			Min: <float> (!)
			Max: <float> (!)
		}
		Exposure: 
		{
			__sizeMode: <int> (!)
			Mode[...]: (!)
			(
				tt__ExposureMode__AUTO: 0,
				tt__ExposureMode__MANUAL: 1,
			)
			__sizePriority: <int>
			Priority[...]: 
			(
				tt__ExposurePriority__LowNoise: 0,
				tt__ExposurePriority__FrameRate: 1,
			)
			MinExposureTime: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
			MaxExposureTime: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
			MinGain: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
			MaxGain: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
			MinIris: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
			MaxIris: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
			ExposureTime: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
			Gain: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
			Iris: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
		}
		Focus: 
		{
			__sizeAutoFocusModes: <int>
			AutoFocusModes[...]: 
			(
				tt__AutoFocusMode__AUTO: 0,
				tt__AutoFocusMode__MANUAL: 1,
			)
			DefaultSpeed: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
			NearLimit: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
			FarLimit: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
		}
		__sizeIrCutFilterModes: <int>
		IrCutFilterModes[...]: 
		(
			tt__IrCutFilterMode__ON: 0,
			tt__IrCutFilterMode__OFF: 1,
			tt__IrCutFilterMode__AUTO: 2,
		)
		Sharpness: 
		{
			Min: <float> (!)
			Max: <float> (!)
		}
		WideDynamicRange: 
		{
			__sizeMode: <int> (!)
			Mode[...]: (!)
			(
				tt__WideDynamicMode__OFF: 0,
				tt__WideDynamicMode__ON: 1,
			)
			Level: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
		}
		WhiteBalance: 
		{
			__sizeMode: <int> (!)
			Mode[...]: (!)
			(
				tt__WhiteBalanceMode__AUTO: 0,
				tt__WhiteBalanceMode__MANUAL: 1,
			)
			YrGain: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
			YbGain: 
			{
				Min: <float> (!)
				Max: <float> (!)
			}
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
		}
		Extension: 
		{
			__size: <int>
			__any: <_XML>
			ImageStabilization: 
			{
				__sizeMode: <int> (!)
				Mode[...]: (!)
				(
					tt__ImageStabilizationMode__OFF: 0,
					tt__ImageStabilizationMode__ON: 1,
					tt__ImageStabilizationMode__AUTO: 2,
					tt__ImageStabilizationMode__Extended: 3,
				)
				Level: 
				{
					Min: <float> (!)
					Max: <float> (!)
				}
				Extension: 
				{
					__size: <int>
					__any: <_XML>
				}
				__anyAttribute: <_XML>
			}
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
		}
		__anyAttribute: <_XML>
	}
}
]==]

