local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local ptz = require "ptzModule"
if not ptz or not ptz.ptz_obj then
	return SVC_OK
end


if request.Velocity then
	if request.Velocity.PanTilt then
		local pt = request.Velocity.PanTilt
		if pt.x < 0 then
			ptz.ptz_obj:MoveLeft( -pt.x )
		elseif pt.x > 0 then
			ptz.ptz_obj:MoveRight( pt.x )
		end

		if pt.y < 0 then
			ptz.ptz_obj:MoveDown( -pt.y )
		elseif pt.y > 0 then
			ptz.ptz_obj:MoveUp( pt.y )
		end
	end
	
	if request.Velocity.Zoom then
		local zm = request.Velocity.Zoom
		if zm.x < 0 then
			ptz.ptz_obj:ZoomOut(-zm.x)
		elseif zm.x > 0 then
			ptz.ptz_obj:ZoomIn(zm.x)
		end
	end

	return SVC_OK
else
	return SVC_OK
end

--[==[ *ABSTRACT* The 'request' arguments:
{
	ProfileToken: <char*> (!)
	Velocity: (!)
	{
		PanTilt: 
		{
			x: <float> (!)
			y: <float> (!)
			space: <char*>
		}
		Zoom: 
		{
			x: <float> (!)
			space: <char*>
		}
	}
	Timeout: <LONG64*>
}
]==]

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

