local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/klnk.conf"
}

----------------------------
local klnk_template = DC.OBJ{
    addr = DC.STR(),
    port = DC.INT(),
    timeout = DC.INT(),
    authcode = DC.STR(),
    poly_enabled = DC.INT(),
    polydevs= DC.SET( DC.OBJ {
        id= DC.INT(),
        ifname= DC.STR()
    } )
} : __changed( function(conf,name,action)
	conf:TAB_SAVE()
end)

-------------------------------------------

local failDefault = {
    addr = "175.10.12.214",
    port = 60000,
    timeout = 1000,
    authcode = "admin",
    poly_enabled = 0,
    polydevs = {
        { id = 1, ifname = "modem1" },
        { id = 2, ifname = "modem2" },
    }
}

function _M.Load()
	local conf = CONF.Create({}, klnk_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then
		conf:TAB_BIND(failDefault)
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-----------------------------------------------------------

return _M