require "kiloview.configure_helper"

local function setOprUsername(owner, pObj, val)
	pObj:InternalSetString(val)
	pObj:InternalSetChanged(true)
end

local function setOprPassword(owner, pObj, val)
	pObj:InternalSetString(val)
	pObj:InternalSetChanged(true)
end

local function onAdd(obj)
	local root = obj:Root()
	local i
	local fnd = false
	local valid_pos = -1
	for i=0, 15 do
		if root.users[i].username == obj.username then
			fnd = true
			break
		elseif root.users[i].username == "" and valid_pos == -1 then
			valid_pos = i
		end
	end

	root.lastError.operation = "add"
	if fnd then
		root.lastError.status = "error:exist"
	elseif valid_pos == -1 then
		root.lastError.status = "error:full"
	else
		root.users[valid_pos].username = obj.username
		root.users[valid_pos].password = obj.password
		root.lastError.status = "ok"
	end
end

local function onDelete(obj)
	local root = obj:Root()
	local i
	local fnd = -1
	for i=0, 15 do
		if root.users[i].username == obj.username then
			fnd = i
			break
		end
	end

	root.lastError.operation = "delete"
	if fnd == -1 then
		root.lastError.status = "error:notexist"
	else
		root.users[fnd].username = ""
		root.users[fnd].password = ""
		root.lastError.status = "ok"
	end
end

local function onChange(obj)
	local root = obj:Root()
	local i
	local fnd = -1
	for i=0, 15 do
		if root.users[i].username == obj.username then
			fnd = i
			break
		end
	end

	root.lastError.operation = "change"
	if fnd == -1 then
		root.lastError.status = "error:notexist"
	else
		root.users[fnd].password = obj.password
		root.lastError.status = "ok"
	end
end

MediaUsers_Template = OBJECT({
	add = OBJECT({
		username = { type="string", noPersist=true, value="", onWrite = setOprUsername },
		password = { type="string", noPersist=true, value="", onWrite = setOprPassword }
	}, onAdd ),

	change = OBJECT({
		username = { type="string", noPersist=true, value="", onWrite = setOprUsername },
		password = { type="string", noPersist=true, value="", onWrite = setOprPassword }
	}, onChange ),

	delete = OBJECT({
		username = { type="string", noPersist=true, value="", onWrite = setOprUsername },
	}, onDelete ),

	lastError = OBJECT({
		operation = { type="string", noPersist=true, value="" },
		status = { type="string", noPersist=true, value="ok" }
	}),

	users = ARRAY(
		{0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15},
		OBJECT({
			username = { type="string", value="" },
			password = { type="string", value="" }
		})
	)
})
