local DC = require "supertable.declare"
local CONF = require "supertable.core"

----------------------------
local _M = {
	config_location = "/data/configs",
	config_file = "timer.conf"
}

----------------------------

local timer_template = 
	DC.OBJ({
                enable = DC.INT(0),
                policy = DC.STR("day"),
                useNtp = DC.BOOL(false),
                date = DC.STR("1970-01-01 00:00:00"),
                hour = DC.INT(0),
                minute = DC.INT(0),
                week = DC.STR("0"),
                day = DC.STR("1"),
                month = DC.STR("1"),
                days = DC.STR("1"),
                rebootDate = DC.STR("1970-01-01"),	
}) : __changed( function(conf)
	conf:TAB_SAVE()
end)

----------------------------

local failDefault = {
        enable=0,policy="day",date=os.date("%Y-%m-%d",os.time()),
        hour=0,minute=0,week="0",day="1",month="1",days="1",rebootDate="1970-01-01"
}

-------------------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, timer_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_location .. "/" .. _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then --Try load a fail-default configure 
		conf:TAB_BIND(failDefault)
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M


