------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=WWAN}: 获得当前无线Modem设备(WWan)的详细状态信息
##ARGUMENTS{GET,POST}: 
	@@DeviceName: 必选参数。Modem设备名，Device值（参见 ^^REF{getNetInterface.lua}, 类型为MODEM）
    ~~

##RETURNS: 


	++Data{OBJ}:
		++3gppInfo{OBJ}: SIM卡信息（如modem1）
			**Imei: SIM卡IMEI
			**RegistrationState{INT}:注册状态
			**OperatorName: 当前注册的运营商的名称
			**OperatorCode{INT}: 当前注册的运营商代码
			**EnabledFacilityLocks{INT}:是否启用PIN锁定
			
		~~
		**ModemObj{OBJ}: Modem对象
		++ModemInfo{OBJ}: Modem信息
			**Sim: sim对象路径
			**CurrentCapabilities{INT}: 当前的访问技术
			**MaxBearers{INT}: 已定义包数据承载器的最大数量
			**MaxActiveBearers{INT}: 活动包数据承载器的最大数量
			**Manufacturer: 设备制造商
			**Model: 设备型号
			**Revision: 软件版本
			**DeviceIdentifier: 设备标识符
			**Device: usb_device对象的sysfs路径
			**Drivers: 操作系统设备驱动程序处理与调制解调器硬件的通信
			**Plugin: 处理调制解调器的插件名
			**PrimaryPort: 控制调制解调器的主端口名
			**EquipmentIdentifier: 设备标识，IMEI号码
			**UnlockRequired: 设备的当前锁定状态
			**UnlockRetries: 剩余PIN尝试数
			**State: 调制解调器的总体状态，以MMModemState值给出
			**StateFailedReason: 调制解调器处于MM_MODEM_STATE_FAILED状态的错误值
			**AccessTechnologies: 当前网络访问技术
			**SignalQuality: 信号质量
			**OwnNumbers: 调制解调器当前处理的数字列表
			**PowerState: 调制解调器当前功率状态
			**SupportedModes: 支持的模式组合
			**CurrentModes: 当前的模式，查看上述的MMModemMode
			**SupportedBands: 设备支持的射频和技术频带
			**CurrentBands: 当前的频带
			**SupportedIpFamilies: 设备支持的IP家族			
        ~~
	~~
]]

local WWAN = require "M_WWanSet"
local cgilua = require "cgilua"
local cjson = require "cjson"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local name
local lang = "en"
local args = require("M_Request").VerifyAndGetArgs()
if args then
	name = args.DeviceName
    lang = args._LANG or "en"
end

local device = WWAN.GetModemInfo(name)
if not device then
	cgilua.put([[
{
	"Result":500,
	"Status":"FAIL: Fault to get WWan device"
}
]])
else
ret ={                                                                       
        Result = 200,                                         
        Status = "OK",                                                                                                                                                                       
        Data = device
}                                                
                                                 
cgilua.put(cjson.encode(ret))
	return
end


