------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=ENCODING}: 获得当前的编码/Streaming模式

>>  KILOVIEW编码产品支持 "主码流 + 子码流" 或 "主码流" 模式。本API可以获取当前的编码/Streaming模式。

##ARGUMENTS: 
    无

##RETURNS: 
	++Data{OBJ}:
        **Mode: Streaming模式 
            %%main: 仅主码流
            %%main+sub: 主码流 + 子码流
        ~~
	~~
]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local r,cc,rets = rpc.Call( "BUS.Get", { ["encoder.encode_mode"] = "main" } )
if not r or not rets then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Fail to get streaming mode configuration"
}
]])
	return
end

cgilua.put([[
{
	"Result":200,
	"Status":"OK",
	"Data":{
		"Mode":"]] .. rets["encoder.encode_mode"] .. [["
	}
}
]])

