------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=PORTFWD}: Remove all port forwarding items
##ARGUMENTS{GET,POST}: 
NONE

##RETURNS{DEFAULT}: 

]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
local r = rpc.Call( "PORT_FWD.Clear" )

if not r then
	cgilua.put([[
	{
		"Result":400,
		"Status":"system-error"
	}
	]])
	return
end

cgilua.put([[
{
	"Result":200,
	"Status":"OK"
}
]])

