------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=WWAN}: 向指定无线Modem设备(WWan)发送AT指令
##ARGUMENTS{GET,POST}: 
	@@DeviceName: 必选参数。Modem设备名，Device值（参见 ^^REF{getNetInterface.lua}, 类型为MODEM）
	@@Command: 必选参数。AT Command with \r\n
    ~~

##RETURNS: 


	++Data{OBJ}:
		**ret{BOOL}: true/false
		**info: 执行AT指令后返回
	~~
]]

local WWAN = require "M_WWanSet"
local cgilua = require "cgilua"
local cjson = require "cjson"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local name
local cmd
local lang = "en"
local args = require("M_Request").VerifyAndGetArgs()
if not args or not args.DeviceName or not args.Command then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Invalid request arguments"
}
]])
	return
end

if args then
	name = args.DeviceName
	cmd = args.Command
    lang = args._LANG or "en"
end

local ret = {}

local r,info = WWAN.ModemCommand(name,cmd)
ret ={                                                                       
        Result = 200,                                         
        Status = "OK",                                                                                                                                                                       
        Data = {
			ret = r,
			info = info
		}
}                                                
                                                 
cgilua.put(cjson.encode(ret))


