------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=BASIC}: 设置设备的名称

##ARGUMENTS{GET,POST}: 
  @@HOST_NAME: 设备主机名称，决定网络访问时所能获得的网络名称
  @@FRIENDLY_NAME: 设备友好名称，该名称可以决定Onvif探测协议得到的名称

##RETURNS{DEFAULT}:

]]

local cgilua = require "cgilua"
local mBasic = require "M_Basic"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
if not args then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Invalid arguments"
}]])
	return
end

if args.HOST_NAME then
	mBasic.SetHostName( args.HOST_NAME)
end

if args.FRIENDLY_NAME then
	mBasic.SetFriendlyName( args.FRIENDLY_NAME )
end

if args.GROUP_NAME then
	mBasic.SetNDIConfig(args)
end

cgilua.put([[
{
	"Result":200,
	"Status":"OK"
}]])

