------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=BASIC}: 配置Web (HTTP)服务端口
##ARGUMENTS{GET,POST}:
  @@ServicePort{INT}: HTTP服务端口（默认80）

##RETURNS: 

##NOTES:
>>{BOLD} 注意：
>> 由于HTTP API使用和Web服务相同的服务端口，因此，修改服务端口将同样影响HTTP API的访问。为确保当前的Web服务和HTTP API
不被中断，修改Web端口后，必须重新启动设备（参见^^REF{reboot.lua}）方能生效！
]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
if not args or not args.ServicePort or not tonumber(args.ServicePort) then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Invalid arguments"
}
]])
	return
end

local sets = { ["webConfig.port"] = tonumber(args.ServicePort) }
local r,x = rpc.Call( "BUS.Set", sets )
if r and x then
	cgilua.put([[
{
	"Result":200,
	"Status":"OK"
}
]])

else
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Fail to set arguments"
}
]])

end

