local args_get = ngx.req.get_uri_args()
local args, arrIdx = {}
for k,v in pairs(args_get) do
	if type(k) == "number" then
		arrIdx = nil
	else
		arrIdx = k:match("(.*)%[%]")
	end
	if arrIdx then
		args[arrIdx] = v
	else
		args[k] = v
	end
end

local client = require "coaf.client"
local adapter = require "coaf.cli_adapter.simple"
adapter.timeoutUnit = 6000
client.InitSocket(nil, adapter)

local function GetProxy(objPath, service, loc, timeout, socket_addr)
	local proxy
	local cli

	cli = client.New( service, loc, socket_addr, timeout or 10 ) --5 seconds timeout.
	if not cli then
		ngx.log( ngx.ERR, "Fail to create connection to service '" .. (loc or "local") .. "/" .. (service or "nil") )
		return nil
	end
	proxy = cli:CreateProxy(objPath, true) --Exclusive
	if not proxy then
		ngx.log( ngx.ERR, "Fail to create object proxy for '" .. (objPath or "unknown") .. "'" )
		return nil
	end
	return proxy
end

if not args.token then
    ngx.log(ngx.ERR, "not have the args token and return ")
    return ngx.exit(403)
end

local proxy = GetProxy("/client", "kilolinkClient")
if proxy then
    local is_ok, skip = proxy.CheckProxyToken(args.token)
    proxy:Destroy()
    if not is_ok or not skip then
        ngx.log(ngx.ERR, "is_ok = ", tostring(is_ok), "skip = ", tostring(skip))
        return ngx.exit(403)
    end
end


