local _dbg = require "coaf.debug"
local client = require "kiloview.coafClientInit"

if not ngx.var.hls_session then
	ngx.status = 404
	return
end

local function GetCoAFProxy( objPath, service, loc, timeout )
	local proxy
	local cli
	cli = client.New( service, loc or "local", nil, timeout or 3 ) --3 seconds timeout.
	if not cli then
		_dbg.Error( "WEB", "Fail to create connection to service: " .. (loc or "local") .. "/" .. (service or "nil") )
		return nil
	end
	proxy = cli:CreateProxy(objPath, true) --Exclusive
	if not proxy then
		_dbg.Error( "WEB", "Fail to create object proxy for '" .. (objPath or "unknown") .. "'" )
		return nil
	end
	return proxy
end

local proxy = GetCoAFProxy( "/HLS", "streamer", "local", 5 )
if not proxy then
	ngx.status = 500
	return
end

local r, content = proxy.GetM3U8( ngx.var.hls_session )
proxy:Destroy()
if not r or not content then
	ngx.status = 404
	return
end

for r=1, #content do
	if content[r] == "" or content[r]:sub(1,1) == "#" then
		ngx.print( content[r] )
		ngx.print( "\r\n" )
	else --File, so need add prefix.
		--ngx.print( "/hls/" .. ngx.var.hls_session .. "/" .. content[r] )
		ngx.print( content[r] )
		ngx.print( "\r\n" )
	end
end

