--Controller of datetime
local _M = require( "controller.generic" )()
-- local cgilua = require "cgilua"

---------- AJAX Call -----------

local function SetLocation( zone )
	if not zone then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end
	_M.MasterCall( "SYS_STATUS.SetTimezone", zone )
	return  [[ {"Result":200, "Msg":"]] .. _M.langs.SET_LOCATION_DONE .. [[","Refresh":1}]]
end

local function SetTime( method, args )
	if not method or not args then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end

	local r,done = _M.MasterCall( "SYS_STATUS.SetTime", method, args )
	if not r or not done then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	else
		local msg = _M.langs.SET_DONE
        return  [[ {"Result":200, "Msg":"]] .. msg .. [[","Refresh":1}]]
	end
end

local function GetTimeDateInfo()
	local r, info = _M.MasterCall( "SYS_STATUS.GetTimeUpdateStatus" )
	if not r or not info then
		return [[ {"Result":400, "Msg":"", "data": 
		{
			"status":"0" 
		} 
	} ]]
	elseif info == "-1" then
		_M.MasterCall( "SYS_STATUS.SetTimeUpdateStatus", false)
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_ZONE_ARGS .. [[",
			"data":{
				"status":"]] .. tostring(info) .. [[" 
			} 
		}]]
	else
		_M.MasterCall( "SYS_STATUS.SetTimeUpdateStatus", false)
		return [[ {"Result":200, "Msg":"", "data": 
		{
			"status":"]] .. tostring(info) .. [[" 
		} 
	} ]]
	end
end

--------------------------------
_M.AjaxExport("SetLocation", SetLocation, "json" )
_M.AjaxExport("SetTime", SetTime, "json") 
_M.AjaxExport("GetTimeDateInfo", GetTimeDateInfo, "json") 
--------------------------------

return _M
