--Controller of jianbo_set
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"

---------- AJAX Call -----------

local function SaveSet( args )
	if not args or type(args) ~= "table" then
		return [[ {"Result":400, "Msg":"Invalid arguments"}]]
    end
    
    -- if not args.addr or not args.addr:match("%d+%.%d+%.%d+%.%d+") then
    --     return [[ {"Result":400, "Msg":"Invalid REMOTE ADDR"}]]
	-- end
	if not args.addr then
        return [[ {"Result":400, "Msg":"Invalid REMOTE ADDR"}]]
    end

    if not args.port or not tonumber(args.port) then
        return [[ {"Result":400, "Msg":"Invalid REMOTE PORT"}]]
	end

	if not args.poly_enabled or not tonumber(args.poly_enabled) or ( args.poly_enabled ~= "0" and args.poly_enabled ~= "1" ) then
        return [[ {"Result":400, "Msg":"Invalid ENABLE ARG"}]]
	end
	
	local devs = {}
	local tmp = {}
	
	for k,v in pairs(args) do
		if string.sub(k,1,string.len("dev_")) == "dev_" then
			table.insert(tmp, v)
		end
	end

	table.sort(tmp)

	local i=1
	for k,v in pairs(tmp) do
		table.insert(devs, { id = i, ifname = v })
		i = i + 1
	end

	local _x,done,msg = _M.MasterCall( "POLY.SetNetLink", args.addr, args.port, args.authcode, args.timeout, devs, args.poly_enabled )
	if not _x then
		return [[ {"Result":400, "Msg":"]] .. (done or "ERROR") .. [["} ]]
	elseif not done then
		return [[ {"Result":400, "Msg":"]] .. (msg or "ERROR") .. [["} ]]
	else
		return [[ {"Result":200, "Msg":"Updated."}]]
	end
end

--------------------------------
_M.AjaxExport ("SaveSet", SaveSet, "json") 
--------------------------------

return _M

