--Controller of preset
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"
local gmarks = require "global_mark"

------------
local function LoadPreset( id )
	local r,x,msg = _M.MasterCall( "BUS.LoadPreset", id )
	if not r then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.LOAD_PRESET_INTERNAL_ERROR .. [["} ]]
	elseif not x then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.LOAD_PRESET_FAIL .. "<br />" .. (msg or "") .. [["} ]]
	else
		return [[ {"Result":200, "Msg":"]] .. _M.langs.LOAD_PRESET_DONE .. [[", "Reload":1 } ]]
	end
end
-------------
local function RemovePreset( id )
	local x,done = _M.MasterCall( "PRESET.DeletePreset", id )
	if x and done then
		return [[ {"Result":200, "Msg":"]] .. _M.langs.REMOVE_PRESET_DONE .. [["} ]]
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.REMOVE_PRESET_FAIL .. [["} ]]
	end
end

local function DoReboot()
	_M.MasterCall( "BUS.Reboot" )
	gmarks.REBOOT = true
	return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_REBOOT_DONE .. [["}]]
end

local function Hello()
	if gmarks.REBOOT then
		return [[ {"Result":400, "Msg":"WAIT" }]]
	else
		return [[ {"Result":200, "Msg":"HELLO" }]]
	end
end

-------------- AJAX CALL ----------------
_M.AjaxExport ("LoadPreset", LoadPreset, "json") 
_M.AjaxExport ("RemovePreset", RemovePreset, "json" )
_M.AjaxExport  ("DoReboot", DoReboot, "json")
_M.AjaxExport  ("Hello", Hello, "json")
---------------------------------------------

return _M

