--Controller of reboot
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"
local gmarks = require "global_mark"
local _dbg = require "coaf.debug"
---------- AJAX Call -----------

local function SaveSet(enable,date,hour,minute,policy,week,day,month,days)
	if  not enable or not policy or not hour or not minute or not week or not day or not month or not days or not date then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end

	if policy == "day" then
		local td = tonumber(day) or -1
		if td < 0 then
			return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
		end
	elseif policy == "mon" then
		if #month == 0 or #days == 0 then
			return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
		end
	elseif policy == "week" then
		if  #week == 0 then
			return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
		end
	end

	local r,x = _M.MasterCall( "BUS.SetRebootTimerInfo", enable,date,hour,minute,policy,week,day,month,days )
	if r and x then 
		return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_SUCCESS .. [["}]]
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_FAIL .. [["}]]
	end

end
--------------------------------
_M.AjaxExport  ("SaveSet", SaveSet, "json") 
--------------------------------

return _M
