--Controller of record_set
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"

---------- AJAX Call -----------

local function SaveSet( args )
	if not args or type(args) ~= "table" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end

	local r,x = _M.MasterCall( "BUS.Set", args )
	if r and x then 
		return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_SAVE_DONE .. [[","Refresh":1 }]]
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_SAVE_FAIL .. [["}]]
	end
end

local function SaveSetUpload(args)
	if not args or type(args) ~= "table" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end

	local r,x = _M.MasterCall( "BUS.Set", args )
	if not r or not x then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_SAVE_FAIL .. [["}]]
	end
	
	r,x = _M.MasterCall("BUS.RecordFTPUpload",args)
	if r and x then 
		return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_SAVE_UPLOAD_DONE .. [[","Refresh":1 }]]
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_UPLOAD_FAIL .. [["}]]
	end
end

local function CheckUploadStatus()
	r,x = _M.MasterCall("BUS.getUploadStatus")
	if r and x then 
		return [[ {"Result":200, "Msg":"HELLO" }]]
	else
		return [[ {"Result":400, "Msg":"WAIT" }]]
	end
end

--------------------------------
_M.AjaxExport  ("SaveSet", SaveSet, "json") 
_M.AjaxExport  ("SaveSetUpload", SaveSetUpload, "json") 
_M.AjaxExport  ("CheckUploadStatus", CheckUploadStatus, "json") 
--------------------------------

return _M
