--Controller of userman
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"

------------
local function AddStatic( interface, target, netmask, gateway,metric,mtu )
    if not interface or not target or not netmask or not gateway or not metric or not mtu then
        return [[ {"Result":400, "Msg":"]] .. "invalid parameter" .. [["}]]
    end

    details = {
        interface  = interface,
        target = target,
        netmask = netmask,
        gateway = gateway,
        metric = metric,
        mtu = mtu,
    }

    local r,x,status = _M.MasterCall( "STATIC.AddStatic", details)
    if not status then
        status = _M.langs.MSG_CHANGE_FAIL
    end
	if r then 
		if x then
			return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_ADD_DONE .. [[", "Refresh":1 }]]
		else
			return [[ {"Result":401, "Msg":"]] .. status .. [[" }]]
		end
	else
		return [[ {"Result":400, "Msg":"]] .. status .. [["}]]
	end
end

local function ChangeStatic( id,interface, target, netmask, gateway,metric,mtu )
    if not interface or not target or not netmask or not gateway or not metric or not mtu or not id then
        return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_NOT_ARGS .. [["}]]
    end
    details = {
        interface  = interface,
        target = target,
        netmask = netmask,
        gateway = gateway,
        metric = metric,
        mtu = mtu,
    }
    local r,x,status = _M.MasterCall( "STATIC.ModifyStatic", id,details)
    if not status then
        status = _M.langs.MSG_CHANGE_FAIL
    end
	if r then 
		if x then
			return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_CHANGE_DONE .. [[", "Refresh":1 }]]
		else
			return [[ {"Result":401, "Msg":"]] .. status.. [[" }]]
		end
	else
		return [[ {"Result":400, "Msg":"]] .. status .. [["}]]
	end
end

local function RemoveStatic(id)
    if not id then
        return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_NOT_ARGS .. [["}]]
    end

    local r,x,status = _M.MasterCall( "STATIC.RemoveStatic", id)
    if not status then
        status = _M.langs.MSG_REMOVE_FAIL
    end
	if r then 
		if x then
			return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_REMOVE_DONE .. [[", "Refresh":1 }]]
		else
			return [[ {"Result":401, "Msg":"]] .. status.. [[" }]]
		end
	else
		return [[ {"Result":400, "Msg":"]] .. status .. [["}]]
	end

end

local function SetStatic(id,statu)

    if not id or not statu then
        return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_NOT_ARGS .. [["}]]
    end

    local r,x,status = _M.MasterCall( "STATIC.SetStatic", id , statu)
    if not status then
        status = _M.langs.MSG_CHANGE_FAIL
    end
	if r then 
		if x then
			return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_CHANGE_DONE .. [[", "Refresh":1 }]]
		else
			return [[ {"Result":401, "Msg":"]] .. status.. [[" }]]
		end
	else
		return [[ {"Result":400, "Msg":"]] .. status .. [["}]]
	end

end
-------------- AJAX CALL ----------------
_M.AjaxExport ("AddStatic", AddStatic, "json") 
_M.AjaxExport ("RemoveStatic", RemoveStatic, "json" )
_M.AjaxExport ("ChangeStatic", ChangeStatic, "json" )
_M.AjaxExport ("SetStatic", SetStatic, "json" )

---------------------------------------------

function _M.GetStatic()
	local r,gets = _M.MasterCall( "STATIC.GetStatic")
	if r and gets then
		return gets
	else
		return {}
	end
end

return _M

