local checkFaults = { "en", "cn" }

local generalLangs = {
	["cn"] = {
		DISABLE_SAVE = "受当前管理员策略控制，您已经被禁止修改这些参数！",
		DISABLE_OPR = "受当前管理员策略控制，您的操作已经被禁止！",
		PRIV_TITLE = "受限",
	},
	
	["tw"] = {
		DISABLE_SAVE = "受當前管理員策略控制，您已經被禁止修改這些參數！",
		DISABLE_OPR = "受當前管理員策略控制，您的動作被禁止！",
		PRIV_TITLE = "禁止",
	},

	["en"] = {
		DISABLE_SAVE = "Because of the privilege control, you are disabled to change these parameters!",
		DISABLE_OPR = "Because of the privilege control, your operation is disabled!",
		PRIV_TITLE = "Denied",
	},

	["jp"] = {
		DISABLE_SAVE = "権限がないため、これらのパラメータを変更することはできません。",
		DISABLE_OPR = "操作は無効です。",
		PRIV_TITLE = "禁止",
	},
	
	["kr"] = {
		DISABLE_SAVE = "권한 이 없 기 때문에 이 매개 변 수 를 변경 할 수 없습니다.",
		DISABLE_OPR = "조작 이 무효 이다",
		PRIV_TITLE = "금지 하 다",

	},
	["pt"] = {
		DISABLE_SAVE = "Controlado PELA atual política de administrador, você FOI Proibido de modificar esses parâmetros!",
		DISABLE_OPR = "Controlado PELA atual política de administração, SUA operação FOI proibida!",
		PRIV_TITLE = "Proibir",

	},

}

local function UpdateGeneralLangs(lang, langTable)
	local gOpts = generalLangs[lang]
	if gOpts then
		local k,v
		for k,v in pairs(gOpts) do
			if not langTable[k] then
				langTable[k] = v
			end
		end
	end
end

return function( pageName, lang )
	local did, langTable = pcall( require, "langs." .. ( lang or "en" ) .. "." .. pageName )
	if did and type(langTable) == "table" then
		UpdateGeneralLangs(lang, langTable)
		return langTable
	else
		local i
		for i=1, #checkFaults do
			did, langTable = pcall( require, "langs." .. checkFaults[i] .. "." .. pageName )
			if did and type(langTable) == "table" then
				UpdateGeneralLangs(checkFaults[i], langTable)
				return langTable
			end
		end
		
		return {}	--An invalid language table.
	end
end
