local modules = require "modules"
local MSG = require "msg"

local module_name = ngx.var.module_name
local method_name = ngx.var.method_name

if not module_name or module_name == "" or not method_name or method_name == "" then
	MSG.ERROR( "错误：无效的请求地址！", { reason = "api:check" } )
	return
end

local module = modules[ module_name ]
if not module or not module.APIS or not module.APIS[method_name] then
	MSG.ERROR( "错误：无效的请求方法！", { reason = "api:method" } )
	return
end

local method = module.APIS[ method_name ]

local red = {"TODO"}

local args = {}
local args_get = ngx.req.get_uri_args()

if module_name == "firmware" and (method_name == "upgrade" or method_name == "fpgaUp") then
	ngx.log( ngx.INFO, "For upload file(s) processing" )
elseif module_name == "pic" and method_name == "add" then
	ngx.log( ngx.INFO, "img file(s) processing" )
else
	ngx.req.read_body()            
	local args_post = ngx.req.get_post_args()
	local k,v
	
	local req_headers = ngx.req.get_headers()
    local content_type = req_headers and (req_headers["Content-Type"] or req_headers["content-type"]) or nil                                                                
    if content_type and content_type:match("application/json") then                                                                                                         
        --Is JSON
        local cjson = require "cjson"   
        local parsed_data={}   
        for k,v in pairs(args_post) do      
            local item=cjson.decode(k)      
            if item then       
                table.insert(parsed_data, item)                                                                                                                             
            end
        end
    
        if #parsed_data == 1 then       
        --Just one json. (likely)           
            args_post = parsed_data[1]  
        else 
        --Unlikely             
            args_post = parsed_data     
        end

	end
	
	local arrIdx
	for k,v in pairs(args_post) do
		arrIdx = k:match("(.*)%[%]")
		if arrIdx then
			args[arrIdx] = v
		else
			args[k] = v
		end
	end
end

--Merge get arguments to post arguments.
for k,v in pairs(args_get) do

	arrIdx = k:match("(.*)%[%]")
	if arrIdx then
		args[arrIdx] = v
	else
		args[k] = v
	end
end

--[[
if module_name ~= "users" or method_name ~= "login" then
		--Check cookie
	local cookie_user = ngx.var["cookie_user"]
	local cookie_token = ngx.var["cookie_token"]
	local cookie_perm = ngx.var["cookie_permlogin"]

	if not cookie_user and not cookie_token then
		if args["AuthUser"] and args["AuthUser"] ~= "" and args["AuthToken"] and args["AuthToken"] ~= "" then
			--For HTTP API using.
			cookie_user = args["AuthUser"]
			cookie_token = args["AuthToken"]
		else
			local recv_headers = ngx.req.get_headers()
			cookie_user = recv_headers["AuthUser"]
			cookie_token = recv_headers["AuthToken"]
		end
	end

	if cookie_perm and (cookie_perm == "1" or cookie_perm == "true" or cookie_perm == "yes" ) then
		cookie_perm = true
	else
		cookie_perm = false
	end

	local r,msg = modules["users"]:CheckSession( red, cookie_user, ngx.var.remote_addr, cookie_token, cookie_perm )
	if not r then
		MSG.ERROR( msg or "检查用户身份失败", { reason = "session" } )
		return
	end

	ngx.ctx["cur_login_user"] = cookie_user
	ngx.ctx["cur_login_token"] = cookie_token
	ngx.ctx["cur_login_perm"] = cookie_perm
end
--]]

local r,msg = method( red, args )
if not r then
	MSG.ERROR( msg or "未知错误", { reason = "api:execute", module = module_name, method = method_name } )
	return
end

