local MSG = require "kvs_msg"
local GetProxy = require "kvs_coservice".GetProxy

local _M = {}

function _M.Get()
    local proxy = GetProxy("/client", "kilolinkClient")
    if not proxy then
        MSG.ERROR("systemError")
        return true
    end
    local is_ok, data, status = proxy.GetConfig()
    proxy:Destroy()
    if not is_ok then
        MSG.ERROR("systemError")
        return true
    end

    MSG.OK("", {cfg = data, status = tonumber(status)})
    return true
end

function _M.Set(_, args)
    local cfg = args.cfg
    if type(cfg) ~= "table" then
        MSG.ERROR("argumentError")
        return true
    end
    local proxy = GetProxy("/client", "kilolinkClient")
    if not proxy then
        MSG.ERROR("systemError")
        return true
    end
    local is_ok, skip = proxy.UpdateConfig(cfg)
    proxy:Destroy()
    if is_ok and skip then
        MSG.OK("")
    else
        MSG.ERROR("systemError")
    end
    return true
end

function _M.NetworkInterface()
    local proxy = GetProxy("/client", "kilolinkClient")
    if not proxy then
        MSG.ERROR("systemError")
        return true
    end
    local is_ok, data = proxy.NetworkInterface()
    proxy:Destroy()
    if not is_ok then
        MSG.ERROR("systemError")
        return true
    end

    MSG.OK("", {list = data})
    return true
end

return _M