#!/usr/bin/env lua
local coaf = require "coaf.core"

-- disk-attach.lua <device> <type:sdmmc/usb> <file-system:ntfs/vfat> [<volumn name>]

--Get shine arguments.
if type(arg) ~= "table" or #arg < 3 then
	os.exit(1)
end

local dbusCli = require "kiloview.dbusClients"
local _DECL = require "kiloview.dbus.sunshine_record"

dbusCli.Init( "SYSTEM" )

--Try start record manager service first!
os.execute( "/usr/bin/systemctl start record_manager.service" )

local clientSession = dbusCli.CreateClientSession()
local diskManProxy = clientSession:GetProxy( _DECL.RECORDM_OBJ, _DECL.RECORDM_BUSNAME, _DECL.iDiskManager )
if not diskManProxy then
	print( "ERROR: Could not get disk manager proxy!" )
	os.exit(1)
end

local function mainEntry(loop, idle, revents)
	idle:stop(loop)
	diskManProxy:DiskAttach( arg[1], arg[2], arg[3], arg[4] or "" )
	dbusCli.Stop()
end

dbusCli.RegisterIdleCall( mainEntry )

dbusCli.Run()
