#!/bin/sh

kernel_ver=`/bin/uname -r`

#The font storage patch:
/bin/mkdir -p /data/fonts
for item in `/bin/ls /usr/share/fonts/*.ttf 2>/dev/null`; do
	if ! /usr/bin/test -L "$item"; then
		/bin/cp -f "$item" /data/fonts/
		/bin/sync
		/bin/ln -sf /data/fonts/$(basename "$item") "$item"
		/bin/sync
	fi
done

for item in `/bin/ls /data/fonts/*.ttf 2>/dev/null`; do
	if /usr/bin/test -f "$item"; then
		linkto=`/usr/bin/readlink -f /usr/share/fonts/$(basename "$item")`
		if /usr/bin/test "$linkto" != "$item" ; then
			rm -Rf /usr/share/fonts/$(basename "$item") 2>/dev/null
			/bin/ln -sf "$item" /usr/share/fonts/$(basename "$item")
			/bin/sync
		fi
	fi
done

if ! /usr/bin/test -d /data/update; then
	/bin/mkdir -p /data/update
fi

upgrade_did="no"
action_code=1

if /usr/bin/test -f /data/update/upgrade.sh; then
	upgrade_did="yes"
	/bin/chmod +x /data/update/upgrade.sh
	cd /data/update
	/data/update/upgrade.sh /data/update
	action_code=$?
elif /usr/bin/test -f /data/update/upgrade.lua; then
	upgrade_did="yes"
	cd /data/update
	/usr/bin/lua /data/update/upgrade.lua -e UPDATE_LOC=\"/data/update\"
	action_code=$?
else
	/bin/rm /data/update/* -Rf	#Drop all files no used.
fi

if /usr/bin/test -x /usr/bin/check_hardware_dts.lua; then
#Should install i2c driver first!
	/sbin/modprobe i2c-dev
	update_dts_bin=`/usr/bin/check_hardware_dts.lua`
	if /usr/bin/test "$update_dts_bin" != "" -a -f "$update_dts_bin"; then
		/usr/bin/upgrade_partition -d "$update_dts_bin"
		if /usr/bin/test $? -eq 0; then
			require_reboot="yes"
			if /usr/bin/test -f /etc/current_hardware_dts.conf; then
				require_reboot="no"
			fi
			/bin/echo "$update_dts_bin" > /etc/current_hardware_dts.conf
			/bin/sync
			if /usr/bin/test "$upgrade_did" != "yes" -a "$require_reboot" = "yes"; then
				/sbin/reboot
				exit 0
			fi
		fi
	fi
fi

if /usr/bin/test "$upgrade_did" = "yes"; then
	if /usr/bin/test $action_code -eq 0; then
		/bin/rm /data/update/* -Rf
	elif /usr/bin/test $action_code -eq 1; then
		/bin/rm /data/update/* -Rf
		/sbin/reboot
	elif /usr/bin/test $action_code -eq 2; then #No remove all files, but reboot
		/sbin/reboot
	else
		/bin/rm /data/update/* -Rf
		/sbin/reboot
	fi
fi

exit 0

