local periphery = require "periphery"
local lfs = require "lfs"
-- local pt = require "pl.pretty"
local SERIAL = periphery.Serial
local _dbg		= require "coaf.debug"

local function check(dev)
    local serial_port
    local status, err = pcall(function()
        serial_port = SERIAL( dev, 9600)
    end)
    if status then
        _dbg.Info("SERIAL", "Serial port open done!", dev)
        local rxData
        status, err = pcall( function() rxData = serial_port:read( 4, 5000 ) end )
        if not status then
            print( "SERIAL_CTRL", "Serial I/O fail, aborted." )
        else
            if rxData and #rxData > 0 and rxData == "kled" then
                print( "SERIAL_CTRL", "New tally LED detected!", dev )
                os.execute("/usr/local/bin/cocall.lua local streamer /streams AddTally ".. dev .. " &")
            else
                print( "SERIAL_CTRL", "No tally LED detected!", dev )
                serial_port:close()
                serial_port = nil
            end
        end
    else
        print( "SERIAL_CTRL", "Serial I/O Open fail, aborted." )
    end

    if nil ~= serial_port then
        serial_port:close()
        serial_port = nil
    end
end

if arg[1] then
    check(arg[1])
else
    for item in lfs.dir("/sys/class/tty") do
		local dev
		local id = item:match("ttyUSB(%d+)")
        if id then
            dev = "/dev/ttyUSB" .. id
            check(dev)
        end
    end
end