--local support_posix, posix = pcall(require, "posix" )
--local support_ev, ev = pcall(require, "ev")

local ver = _VERSION:match("Lua (.*)$")
ver = tonumber(ver) or 5.1

------------------------------------
local _M = {
	lua_version = ver,
	__posix_supports = {},
	__ev_support = nil,
}

------------------------------------
if ver < 5.3 then
	if ver == 5.2 and bit32 then
		_M.bit = bit32
	else
		local _x, bit = pcall( require, "bit" )
		if _x and bit then
			_M.bit = bit
		end
	end
end

------------------------------------
if ngx then
	_M.found_ngx = true
end

if ngx and ngx.socket then -- Check in openresty environment?
	_M.found_ngx_socket = true
end

------------------------------------

function _M.IsOpenresty()
	return _M.found_ngx and _M.found_ngx_socket
end

------------------------------------

function _M.CheckEv()
	if _M.__ev_support then
		return _M.__ev_support.module
	else
		local support, mod = pcall( require, "ev" )
		_M.__ev_support = {
			module = support and mod or nil
		}
		return support and mod or nil
	end
end

------------------------------------
function _M.CheckPosix(name)
	if _M.__posix_supports[name] then
		return _M.__posix_supports[name].module
	else
		local support, mod = pcall( require, name )
		_M.__posix_supports[name] = {
			module = support and mod or nil
		}
		return support and mod or nil
	end
end

------------------------------------

return _M

