require "kiloview.configure_helper"

local function setRecordStart(owner,pObj,value)
	local diskRecorder = require "diskRecorder"
	pObj:InternalSetInt(value)
	pObj:InternalSetChanged(false)

	if _G.CONFIG_LOADING then
		return
	end

	local streamId = owner:Name()
	if tonumber(value) ~= 0 then
		diskRecorder.StartRecord( streamId )
	else
		diskRecorder.StopRecord( streamId )
	end
end

local function onRecordParamsChanged(obj)
	if obj.start ~= 0 then	--Is started, so try update recording arguments.
		local streamId = obj:Name()
		diskRecorder.StartRecord( streamId )
	end
end

RECORD_MAN_Template = OBJECT({
	stream = ARRAY(
		{0,1},
		
		OBJECT({
			auto_record = { type="integer", value=0 },
			signal_record = { type="integer", value=0 },
			start = { type="integer", value=0, noPersist=true, onWrite = setRecordStart },
			disk_type = { type="string", value="largest" },
			format = { type="string", value="ts" },
			file_prefix = { type="string", value="REC" },
			limit_type = { type="string", value="size-loop" },
			limit_size = { type="integer", value=1000000 },
			limit_time = { type="integer", value=3600 },
			disk_policy = { type="string", value="overwrite" },
			auto_upload = { type="integer", value=0 },
			upload_time_hour = { type="string", value="12" },
			upload_time_minute = { type="string", value="00" },
			host = { type="string", value="127.0.0.1" },
			user = { type="string", value="" },
			password = { type="string", value="" },
			path = { type="string", value="/" },
			signal_enable = {type="string","false"},

		}, onRecordParamsChanged )
	)
})

