--Product restore factory settings
local _M = {}

require "features"

function _M.RestoreFactory()
	--(1) Drop all configures [so defaults will be replaced]
	os.execute( "/bin/rm -Rf /data/configs/*.conf" )	--Ignore the .sys-conf
	os.execute( "/bin/rm -f /etc/record_m.conf" ) --Also drop recording settings. (NEW fixed)
	--(2) Reset the IP address
	os.execute( "/bin/rm -Rf /etc/NetworkManager/system-connections/*" )
	--(3) Images
	os.execute("/bin/rm -Rf /data/osd_images/*")
	--(4) Presets
	os.execute("/bin/rm -Rf /data/presets/*")

	os.execute( "/bin/cp -Rf /etc/sys-preset/default/configs/* /data/configs/" )
	os.execute( "/bin/cp -Rf /etc/sys-preset/default/etc/* /etc/" )
	--Overwrite if exist.
	os.execute( "/bin/cp -Rf /etc/sys-preset/user/configs/* /data/config/" )
	os.execute( "/bin/cp -Rf /etc/sys-preset/user/etc/* /etc/" )

	os.execute( "/bin/cp -Rf /etc/hostname.default /etc/hostname" )

	--Restore telnet setting.
	os.execute("/bin/ln -sf /usr/lib/systemd/system/telnet.socket /usr/lib/systemd/system/sockets.target.wants/telnet.socket")

	local eth0_cfg = io.open( "/etc/NetworkManager/system-connections/ethernet-eth0", "r" )
	if not eth0_cfg then --Not exist, so I need create one manually.
		--eth0
		eth0_cfg = io.open( "/etc/NetworkManager/system-connections/ethernet-eth0", "w" )
		if not eth0_cfg then
			print( "***ERROR: Could not create the default ethernet(eth0) configure file!" )
		else
			eth0_cfg:write( [==[
[connection]
id=ethernet-eth0
uuid=d873cce7-4bf7-4e04-89d7-2263fe2bc47a
type=ethernet
interface-name=eth0
permissions=
secondaries=

[ethernet]
cloned-mac-address=
mac-address-blacklist=

[ipv4]
address1=192.168.1.168/24,192.168.1.1
dns=192.168.1.1;
dns-search=
method=manual

[ipv6]
dns-search=
method=auto
]==])
			eth0_cfg:close()
		end
	else
		eth0_cfg:close()
	end

	os.execute( "/bin/chmod 600 /etc/NetworkManager/system-connections/*" )

	local cfgfile = "/etc/sys-preset/user/cfg.lua"
	local f = io.open( cfgfile, "r" )
	if not f then
		cfgfile = "/etc/sys-preset/default/cfg.lua"
		f = io.open( cfgfile, "r" )
		if not f then
			cfgfile = nil
		else
			f:close()
		end
	else
		f:close()
	end

	if cfgfile then
		local x, cfg = pcall( dofile, cfgfile )
		if x and type(cfg) == "table" then
			if cfg.system and type(cfg.system_timedate) == "table" then
				if cfg.system_timedate.ntp_enabled == "yes" or cfg.system_timedate.ntp_enabled == "true" then
					os.execute( "/usr/bin/timedatectl set-ntp TRUE" )
				else
					os.execute( "/usr/bin/timedatectl set-ntp FALSE" )
				end

				if cfg.system_timedate.zone then
					os.execute( "/usr/bin/timedatectl set-timezone \"" .. cfg.system_timedate.zone .. "\"" )
				end
			end
		end
	end
	
	--(3) Reboot
	return "reboot"	--Notify the caller should reboot!
end

return _M
