local _M = {}

_M.iConfigure = "com.kiloview.SUNSHINE.Module.iConfigure"
_M.iConfigureEvents = "com.kiloview.SUNSHINE.Module.iConfigureEvents"

_M.iConfigure_decl = [[
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN"
"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node>
  <interface name="]] .. _M.iConfigure .. [[">
    <property name="ConfigPrefix" type="s" access="read"/>

    <method name="Set">
      <arg type="a{sv}" name="inParams" direction="in" />
	  <arg type="i" name="result_status" direction="out" />
	</method>

    <method name="SetEnv">
      <arg type="a{sv}" name="inParams" direction="in" />
	  <arg type="i" name="result_status" direction="out" />
	</method>

    <method name="Get">
      <arg type="a{sv}" name="inParams" direction="in" />
	  <arg type="i" name="result_status" direction="out" />
      <arg type="a{sv}" name="outParams" direction="out" />
	</method>

    <method name="GetEnv">
      <arg type="a{sv}" name="inParams" direction="in" />
	  <arg type="i" name="result_status" direction="out" />
      <arg type="a{sv}" name="outParams" direction="out" />
	</method>

    <method name="RestoreDefault">
	  <arg type="i" name="result_status" direction="out" />
	</method>
	
	<method name="LoadConfigureFile">
	  <arg type="s" name="fileName" direction="in" />
	  <arg type="i" name="result_status" direction="out" />  
	</method>
  </interface>
</node>
]]

----------

_M.iConfigureEvents_decl = [[
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN"
"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node>
  <interface name="]] .. _M.iConfigureEvents .. [[">
    <signal name="ConfigureChanged">
      <arg type="s" name="prefix" direction="in"/>
      <arg type="a{si}" name="details" direction="in"/>
    </signal>

    <signal name="EnvChanged">
      <arg type="s" name="prefix" direction="in"/>
      <arg type="a{si}" name="details" direction="in"/>
    </signal>
  </interface>
</node>
]]

----------

return _M

