local _M = {}

-------------------------------
_M.RECORDM_BUSNAME = "com.kiloview.SUNSHINE.record_m"
_M.RECORDM_OBJ = "/com/kiloview/SUNSHINE/record_m"

_M.iDiskManager = "com.kiloview.SUNSHINE.record_m.iDiskManager"
_M.iRecord = "com.kiloview.SUNSHINE.record_m.iRecord"
_M.iRecordEvents = "com.kiloview.SUNSHINE.record_m.iRecordEvents"

-------------------------------

_M.iDiskManager_decl = [[
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN"
"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node>
  <interface name="]] .. _M.iDiskManager .. [[">
    <method name="DiskAttach">
		<arg type="s" name="device" direction="in" /> <!-- sda1/sda2/... -->
		<arg type="s" name="type" direction="in" /> <!-- sdmmc/usb/... -->
		<arg type="s" name="filesys" direction="in" /> <!-- vfat/ntfs -->
		<arg type="s" name="volname" direction="in" /> <!-- disk volumn name -->
	</method>

    <method name="DiskDettach">
		<arg type="s" name="device" direction="in" />
	</method>

	<method name="DiskList">
		<arg type="i" name="result_code" direction="out" /> <!-- l.t. 0, OK -->
		<arg type="a{ss}" name="result" direction="out" /> <!-- list of 'device'='Volumn name' -->
	</method>

	<method name="DiskDetail">
		<arg type="s" name="device" direction="in" />
		<arg type="i" name="result_code" direction="out" /> <!-- l.t. 0, OK -->
		<arg type="a{sv}" name="result" direction="out" /> 
		<!-- list of { VOLNAME=..., MOUNT=, DEVICE=..., TYPE=sdmmc/usb/..., FILESYS=vfat/ntfs, TOTAL=, FREE=, USED=, PERCENT= } -->
	</method>

	<method name="DiskRecordList">
		<arg type="s" name="device" direction="in" />
		<arg type="s" name="sequence" direction="in" />
		<arg type="i" name="result_code" direction="out" /> <!-- l.t. 0, OK -->
		<arg type="aa{sv}" name="result" direction="out" /> 
		<!-- array: each item is { PATH, STREAM, SEQUENCE, FILES={filename=size}, FORMAT, START_TIME, END_TME, SIZE, SNAPSHOT } -->
	</method>
  </interface>
</node>
]]

-------------------------------

_M.iRecord_decl = [[
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN"
"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node>
  <interface name="]] .. _M.iRecord .. [[">
	<method name="RegisterWorker">
		<arg type="s" name="stream" direction="in" />	<!-- "main", "sub", "any" -->
	</method>

	<method name="AckStartRecord">
		<arg type="s" name="sequence_id" direction="in" />
		<arg type="s" name="ackCode" direction="in" /> <!-- "done", "no-stream", "start-fail", "unsupport-format", "no-resource", "error" -->
	</method>

	<method name="AckStopRecord">
		<arg type="s" name="sequence_id" direction="in" />
		<arg type="s" name="ackCode" direction="in" /> <!-- "done", "fail", "error" -->
	</method>

	<method name="UpdateRecord">
		<arg type="s" name="sequence_id" direction="in" />
		<arg type="s" name="action" direction="in" /> <!-- "new-file", "update-file", "finish-file", "finish-sequence" -->
		<arg type="s" name="filename" direction="in" />
		<arg type="s" name="format" direction="in" />
		<arg type="s" name="time" direction="in" />
		<arg type="i" name="size_kb" direction="in" />
		<arg type="s" name="result_code" direction="out" />
	</method>

	<method name="GetStatus">
		<arg type="s" name="stream" direction="in" />
		<arg type="s" name="status_code" direction="out" /> <!-- "idle", "starting", "started", "stopping", "stopped", "error:..." -->
		<arg type="a{sv}" name="status" direction="out" /> 
		<!-- { PATH, STREAM, SEQUENCE, FILES={filename=size}, FORMAT, START_TIME, END_TME, SIZE, SNAPSHOT } -->
	</method>
  </interface>
</node>
]]


---------

_M.iRecordEvents_decl = [[
<!DOCTYPE node PUBLIC "-//freedesktop//DTD D-BUS Object Introspection 1.0//EN"
"http://www.freedesktop.org/standards/dbus/1.0/introspect.dtd">
<node>
  <interface name="]] .. _M.iRecordEvents .. [[">
    <signal name="NotifyStartRecord">
      <arg type="s" name="fstype" direction="in" />
      <arg type="s" name="stream" direction="in" />
      <arg type="s" name="sequence_id" direction="in" />
      <arg type="s" name="format" direction="in" />
      <arg type="s" name="path" direction="in" />
      <arg type="s" name="fileprefix" direction="in" />
      <arg type="s" name="limit_type" direction="in" />
      <arg type="i" name="limit" direction="in" />
    </signal>

    <signal name="NotifyStopRecord">
      <arg type="s" name="stream" direction="in" />
      <arg type="s" name="sequence_id" direction="in" />
    </signal>
  </interface>
</node>
]]

------------

return _M
