require "configuredb"

local _M = {}

function _M.SetValues(prefix,params)
	local k,v
	local counter = 0
	local exec = ""
	local pfx = "^" .. prefix .. "."
	for k,v in pairs(params) do
		if k:match(pfx) then
			if prefix == "_ENV" then
				k = k:match("^_ENV%.(.*)")
				exec = exec .. "_G._ENV[\"" .. k .. "\"]="
			else
				exec = exec .. "_G." .. k .. "="
			end	

			if type(v) == "string" then
				exec = exec .. "[=[" .. v .. "]=]\n"
			elseif type(v) ~= nil then
				exec = exec .. v .. "\n"
			end
			counter = counter + 1
		else --Not start with prefix, so add it.
			if prefix == "_ENV" then
				exec = exec .. "_G._ENV[\"" .. k .. "\"]="
			else
				exec = exec .. "_G." .. prefix .. "." .. k .. "="
			end	

			if type(v) == "string" then
				exec = exec .. "[=[" .. v .. "]=]\n"
			elseif type(v) ~= nil then
				exec = exec .. v .. "\n"
			end
			counter = counter + 1
		end
	end

	if counter > 0 then
		local func = load( exec )
		local r,msg = pcall(func)
		if r then
			return counter
		else
			return -1, msg
		end
	else
		return counter
	end
end


function _M.SetConfigureValues(prefix,params)
	local k,v
	local counter = 0
	local exec = "CONFIGS.BeginUpdate()\n"
	local pfx = "^" .. prefix .. "."
	for k,v in pairs(params) do
		if k:match(pfx) then
			if type(v) == "string" then
				exec = exec .. "_G." .. k .. "=[=[" .. v .. "]=]\n"
			elseif type(v) ~= nil then
				exec = exec .. "_G." .. k .. "=" .. v .. "\n"
			end
			counter = counter + 1
		else --Not start with prefix, so add it.
			if type(v) == "string" then
				exec = exec .. "_G." .. prefix .. "." .. k .. "=[=[" .. v .. "]=]\n"
			elseif type(v) ~= nil then
				exec = exec .. "_G." .. prefix .. "." .. k .. "=" .. v .. "\n"
			end
			counter = counter + 1
		end
	end

	if counter > 0 then
		exec = exec .. "CONFIGS.Submit()"
		local func = load( exec )
		local r,msg = pcall(func)
		if r then
			return counter
		else
			return -1, msg
		end
	else
		return counter
	end
end


function _M.GetValues(prefix,params)
	local k,v
	local counter = 0
	local exec = "return function(params)"
	local pfx = "^" .. prefix .. "."
	for k,v in pairs(params) do
		if k:match(pfx) then
			if prefix == "_ENV" then
				exec = exec .. [[params["]] .. k .. [["] = _G._ENV["]]
				k = k:match("^_ENV%.(.*)")
				exec = exec .. k .. "\"]"
			else
				exec = exec .. [[params["]] .. k .. [["] = _G.]] .. k
			end

			if type(v) == "string" then
				exec = exec .. " or [=[" .. v .. "]=]\n"
			elseif type(v) ~= nil then
				exec = exec .. " or " .. v .. "\n"
			end
			counter = counter + 1
		else --Not start with prefix, so add it.
			if prefix == "_ENV" then
				exec = exec .. [[params["]] .. k .. [["] = _G._ENV["]] .. k .. "\"]"
			else
				exec = exec .. [[params["]] .. k .. [["] = _G.]] .. prefix .. "." .. k
			end

			if type(v) == "string" then
				exec = exec .. " or [=[" .. v .. "]=]\n"
			elseif type(v) ~= nil then
				exec = exec .. " or " .. v .. "\n"
			end
			counter = counter + 1
		end
	end

	if counter > 0 then
		exec = exec .. "end"
		local wrapFunc = load( exec )
		local r,func = pcall( wrapFunc )
		if r and type(func) == "function" then
			local msg
			r,msg = pcall(func,params)
			if r then
				return counter
			else
				return -1,msg
			end
		else
			return -1, func
		end
	else
		return counter
	end	
end

return _M

